	SUBROUTINE ENVADD
******************************************************************* 
*  Find cluster sites for every atom to be used in TB-constants.  *
*******************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,ISENV(0:NENVMAX,NPAT),ICENV(0:NENVMAX,0:NENVMAX,NPAT)
     &    ,NKAP(NPANMAX),ILSV(NSORTMAX),NENV(NPAT)
     &    ,IPENV(0:NENVMAX,NPAT,NOPRMAX)
     &    ,IRENV(0:NENVMAX,NPAT)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &    ,ALPDOT(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
     &    ,ALPHA(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
     &    ,DLOG(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
	DIMENSION RBAS(3,3),TAU(3,NPAT),TENV(3,0:NENVMAX,NPAT)
     &    ,RLOC(NSORTMAX),SMT(NSORTMAX),TAUT(3,NPAT)
	LOGICAL FIRST
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /LATTICE/RBAS                                !!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /BASIS/  TAU                                 !!! from init
	COMMON /SCRINP/ RLOC,ALPHA,ALPDOT,DLOG              !!! from init
	COMMON /LATPAR/ PAR                                 !!! from init
	COMMON /ENVSITE/NENV,TENV,ISENV,IPENV,IRENV,ICENV   !!! from envadd
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                   !!! from init
	COMMON /TXTEL/  TXTEL                               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /WORD/   NVAL                                !!! from nmtdata
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
C ***** FIND POINT-INDICATOR ARRAY FOR THREE-CENTER TERMS *****
        DO 1000 IATOM1=1,NATOM
        DO IENV=0,NENV(IATOM1)
        IATOM=ISENV(IENV,IATOM1)
        TXI=TAU(1,IATOM1)+TENV(1,IENV,IATOM1)
        TYI=TAU(2,IATOM1)+TENV(2,IENV,IATOM1)
        TZI=TAU(3,IATOM1)+TENV(3,IENV,IATOM1)
        DO KENV=0,NENV(IATOM1)
        KATOM=ISENV(KENV,IATOM1)
        TXK=TAU(1,IATOM1)+TENV(1,KENV,IATOM1)
        TYK=TAU(2,IATOM1)+TENV(2,KENV,IATOM1)
        TZK=TAU(3,IATOM1)+TENV(3,KENV,IATOM1)
        ICENV(KENV,IENV,IATOM1)=-1
        DO LENV=0,NENV(IATOM)
        TXL=TXI+TENV(1,LENV,IATOM)
        TYL=TYI+TENV(2,LENV,IATOM)
        TZL=TZI+TENV(3,LENV,IATOM)
        ABSR=SQRT((TXL-TXK)**2+(TYL-TYK)**2+(TZL-TZK)**2)
        IF(ABSR.LE.1.D-08)ICENV(KENV,IENV,IATOM1)=LENV
	ENDDO
	ENDDO
	ENDDO
C  CHECK OUT FOR SYMMETRICITY
        DO IENV=0,NENV(IATOM1)
        IATOM=ISENV(IENV,IATOM1)
        DO KENV=0,NENV(IATOM1)
        KATOM=ISENV(KENV,IATOM1)
        LENV=ICENV(KENV,IENV,IATOM1)
        IF(LENV.GE.0)THEN
        LATOM=ISENV(LENV,IATOM)
        IF(LATOM.NE.KATOM)STOP'<ENVADD>:: ERROR IN ICENV'
        ENDIF
        IF((ICENV(KENV,IENV,IATOM1).EQ.-1.
     &  AND.ICENV(IENV,KENV,IATOM1).NE.-1).OR.
     &     (ICENV(IENV,KENV,IATOM1).EQ.-1.
     &  AND.ICENV(KENV,IENV,IATOM1).NE.-1.))
     &  WRITE(IUN,1010)KENV,IENV,IATOM1
	ENDDO
	ENDDO
1000    CONTINUE
1010    FORMAT(1X,'<ENVADD>: SYMMETRY IS BROKEN FOR ',I3,1X,I3,1X,I3)
	END
