	SUBROUTINE PRINT2
***********************************************
*  Print data on the potential and density    *
***********************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),ISPL(NSORTMAX)
	COMPLEX*16 V(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,VDS(3,NSYMMAX,NPAT,NSPINMAX)
     &    ,TCH(NSYMMAX,NPAT,2,NSPINMAX)
     &    ,AMTOT(NSYMMAX,NPAT,NSPINMAX)
     &    ,RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
	DIMENSION SMT(NSORTMAX),VMT(NSORTMAX,NSPINMAX)
     &   ,VSF(NSORTMAX,NSPINMAX),Z(NSORTMAX),ZCOR(NSORTMAX)
     &   ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),SPLIT(NSORTMAX)
     &   ,VAVINT(NPAT,NSPINMAX)
	CHARACTER TXTEL(NSORTMAX)*10,TXTSP(2)*2
	COMMON /CONTROL/MAN,LMTO,NLR,NINT                   !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT,VSPH,V,VDS                  !!! from vfull
	COMMON /DENS/   RO,ROVALDS                          !!! from rofull
	COMMON /VZERO/  VMT0,VMT,VSF0,VSF,VAV,VAVINT        !!! from vzero
	COMMON /MULTRO/ Z,ZCOR,TCH,AMTOT                    !!! from multro
	COMMON /SPIN/   NSPIN,SPLIT,ISPL                    !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /TXTEL/  TXTEL,TXTSP                         !!! from init
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
C  PRINT POTENTIAL AND DENSITY DATA
	ZINT=0.D0
	ATOT=0.D0
	TINT=0.D0
	DO 20 IATOM=1,NATOM
	WRITE(IUN,1000)TXTEL(IS(IATOM)),IATOM
	DO 10 ISPIN=1,NSPIN
	IF(NSPIN.EQ.1)
     &  WRITE(IUN,1010)VMT(IS(IATOM),ISPIN),
     &  DREAL(ROVALDS(1,1,IATOM,ISPIN))/SQPI4
	IF(NSPIN.EQ.2)WRITE(IUN,1020)TXTSP(ISPIN),
     &  VMT(IS(IATOM),ISPIN),TXTSP(ISPIN),DREAL(ROVALDS(1,1,
     &  IATOM,ISPIN))/SQPI4
   10   CONTINUE
	ZINT=ZINT-DREAL(AMTOT(1,IATOM,1)-TCH(1,IATOM,2,1)+
     &  AMTOT(1,IATOM,NSPIN)-TCH(1,IATOM,2,NSPIN))/2.D0*NSPIN
	TINT=TINT+(TCH(1,IATOM,2,1)+TCH(1,IATOM,2,NSPIN))/2.D0*NSPIN
	ATOT=ATOT+DREAL(AMTOT(1,IATOM,1)-AMTOT(1,IATOM,NSPIN))
	WRITE(IUN,1040)(VAVINT(IATOM,1)+VAVINT(IATOM,NSPIN))/2.D0*NSPIN
     &  +VMT0,DREAL(AMTOT(1,IATOM,1)+AMTOT(1,IATOM,NSPIN))/2.D0*NSPIN
	IF(NSPIN.EQ.2)THEN
	WRITE(IUN,1050)DREAL(AMTOT(1,IATOM,1)-AMTOT(1,IATOM,NSPIN)+
     &  TCH(1,IATOM,2,1)-TCH(1,IATOM,2,NSPIN)),DREAL(AMTOT(1,IATOM,1)-
     &  AMTOT(1,IATOM,NSPIN))
	IF(ABS(SPLIT(IS(IATOM))).GE.1.D-10)
     &  WRITE(IUN,1060)DREAL(AMTOT(1,IATOM,1)-AMTOT(1,IATOM,NSPIN)+
     &  TCH(1,IATOM,2,1)-TCH(1,IATOM,2,NSPIN))/SPLIT(IS(IATOM)),
     &  DREAL(AMTOT(1,IATOM,1)-AMTOT(1,IATOM,NSPIN))/SPLIT(IS(IATOM))
	ENDIF
  20    CONTINUE
	WRITE(IUN,1070)VMT0
	IF(NINT.NE.0)WRITE(IUN,1080)VAV
	WRITE(IUN,1090)ZINT
	IF(NINT.NE.0)WRITE(IUN,1100)TINT
	IF(NSPIN.EQ.2)WRITE(IUN,1110)ATOT
1000  FORMAT(1X,'Input data ',A10,' in the position ',I3,' ------->')
1010  FORMAT(1X,'   V(S)=',G14.7,'  |     RO(S)=',G14.7)
1020  FORMAT(1X,'V-',A2,'(S)=',G14.7,'  | RO-',A2,'(S)=',G14.7)
1040  FORMAT(1X,'   V(I)=',G14.7,'  |     Q(C)=',G14.7)
1050  FORMAT(1X,'   M(S)=',G14.7,'  |     M(C)=',G14.7)
1060  FORMAT(1X,'  HI(S)=',G14.7,'  |    HI(C)=',G14.7)
1070  FORMAT(' Average potential over the sphere boundaries is ',G14.7)
1080  FORMAT(' Average potential in the interstitial region is ',G14.7)
1090  FORMAT(' Total charge in the interstitial region must be ',G14.7)
1100  FORMAT(' Total charge found via  one-center expansion is ',G14.7)
1110  FORMAT(' Total magnetization found in elementary cell is ',G14.7)
	RETURN
	END



	SUBROUTINE PRINTC(KEY)
*******************************************************
*  Prints input-output charge.                        *
*******************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSV(NSORTMAX),ILSB(NSORTMAX)
	COMPLEX*16 CELINP(NPAT),CELOUT(NPAT),AMTINP(NPAT),AMTOUT(NPAT)
     &     ,TCH(NSYMMAX,NPAT,2,NSPINMAX),AMTOT(NSYMMAX,NPAT,NSPINMAX)
	DIMENSION Z(NSORTMAX),ZCOR(NSORTMAX)
	CHARACTER TXTEL(NSORTMAX)*10
        COMMON /CONTROL/LIFT,LMTO,NCOU,NINT,NPF                 !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM           !!! from init
	COMMON /MULTRO/ Z,ZCOR,TCH,AMTOT                        !!! from multro
	COMMON /SPIN/   NSPIN                                   !!! from init
	COMMON /TXTEL/  TXTEL                                   !!! from init
        COMMON /UNIT/   IUN                                     !!! from init
	SAVE CELINP,AMTINP
        DATA PI/3.141592653589793D0/
C  SAVE INPUT CHARGE TRANSFER
	IF(KEY.EQ.1)THEN
	DO 10 IATOM=1,NATOM
	CELINP(IATOM)=(AMTOT(1,IATOM,1)+AMTOT(1,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
        AMTINP(IATOM)=AMTOT(1,IATOM,1)-AMTOT(1,IATOM,NSPIN)
   10 	CONTINUE
	ELSEIF(KEY.EQ.2)THEN
	DO 20 IATOM=1,NATOM
	CELOUT(IATOM)=(AMTOT(1,IATOM,1)+AMTOT(1,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
        AMTOUT(IATOM)=AMTOT(1,IATOM,1)-AMTOT(1,IATOM,NSPIN)
   20	CONTINUE
C  PRINT CELL CHARGES
	WRITE(IUN,1010)
	WRITE(IUN,1020)
	DO 30 IATOM=1,NATOM
	WRITE(IUN,1030)DREAL(CELINP(IATOM)),DREAL(CELOUT(IATOM)),
     &  TXTEL(IS(IATOM))
   30 	CONTINUE
        IF(NSPIN.EQ.2)THEN
        WRITE(IUN,1040)
        WRITE(IUN,1050)
        DO 40 IATOM=1,NATOM
        WRITE(IUN,1030)DREAL(AMTINP(IATOM)),DREAL(AMTOUT(IATOM)),
     &  TXTEL(IS(IATOM))
   40   CONTINUE
        ENDIF
	WRITE(IUN,1060)
	ENDIF
1010	FORMAT(1X,'Input/output charge transfer at the iteration  --->')
1020	FORMAT(1X,'    C(inp)              C(out)')
1030	FORMAT(1X,G14.7,6X,G14.7,2X,A)
1040    FORMAT(1X,'Input/output magnetic moment at the iteration  --->')
1050    FORMAT(1X,'    M(inp)              M(out)')
1060    FORMAT(63('*'))
	END
