*******************************************************************
*      z ^        x2 
*        |       /
*        |     /   PLANE
*        |   x1--------x3
*        |
*        .------------------->
*      /                      x
*    /
*  y
*******************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	parameter (ndrmax=500)
	CHARACTER*60 INIFILE,SCFFILE,STRFILE
	INTEGER IS(NPAT),ILS(NSORTMAX),NRAD(NSORTMAX)
     &  ,IATREF(0:NDRMAX,0:NDRMAX),NSHE(NSORTMAX),NPOL(0:NSORTMAX)
	DIMENSION SROU(NSORTMAX),SW1(NPAT)
     &  ,FUN0(0:NRADMAX,NSORTMAX),X1(3),X2(3),X3(3)
     &  ,R(0:NRADMAX,NSORTMAX),RINT(0:NSHEMAX,NSORTMAX)
     &  ,ORTH(2:3),TAU(3,NPAT),TAU0(3,NPAT)
     &  ,VNET(3,0:NDRMAX,0:NDRMAX),PLNET(3,0:NDRMAX,0:NDRMAX)
     &  ,X(0:NDRMAX),Y(0:NDRMAX),Z(0:NDRMAX,0:NDRMAX)
     &  ,WXR1(0:NRADMAX,LMMAXV,NPAT),WYR1(0:NRADMAX,LMMAXV,NPAT)
     &  ,WZR1(0:NRADMAX,LMMAXV,NPAT),WXI1(0:NRADMAX,LMMAXV,NPAT)
     &  ,WYI1(0:NRADMAX,LMMAXV,NPAT),WZI1(0:NRADMAX,LMMAXV,NPAT)
     &  ,WXR2(0:NSHEMAX,LMMAXV,NPAT),WYR2(0:NSHEMAX,LMMAXV,NPAT)
     &  ,WZR2(0:NSHEMAX,LMMAXV,NPAT),WXI2(0:NSHEMAX,LMMAXV,NPAT)
     &  ,WYI2(0:NSHEMAX,LMMAXV,NPAT),WZI2(0:NSHEMAX,LMMAXV,NPAT)
     &  ,FUNR1(0:NRADMAX,LMMAXV,NPAT),FUNI1(0:NRADMAX,LMMAXV,NPAT)
     &  ,FUNR2(0:NSHEMAX,LMMAXV,NPAT),FUNI2(0:NSHEMAX,LMMAXV,NPAT)
	COMPLEX*16 FUN(0:NRADMAX,LMMAXV,NPAT),FUNDS(3,LMMAXV,NPAT)
     &  ,FUNINT(0:NSHEMAX,LMMAXV,NPAT),YLM(LMMAXV)
	COMMON /PARAM/  NSORT,IS,ILS,NATOM,NSPIN
	COMMON /LATTICE/A(3),B(3),C(3)
	COMMON /BASIS/  TAU
	COMMON /BASIS0/ TAU0
	COMMON /RADMESH/NRAD,R,RINT
	COMMON /LATPAR/ PAR,ORTH
	COMMON /SRFINP/ SW(NSORTMAX)
	COMMON /COMFUN/ FUN,FUNINT,FUNDS,FUN0
	COMMON /POTCOM/ SWZ,SMT(NSORTMAX)
	COMMON /INTMESH/NSHE,NPOL,SROU
	COMMON /TXTEL/  TXTEL
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
	WRITE(6,1000)'INIFILE? '
	READ(5,1001)INIFILE
	WRITE(6,1000)'SCFFILE? '
	READ(5,1001)SCFFILE
	WRITE(6,1000)'STRFILE? '
	READ(5,1001)STRFILE
	CALL READINI(INIFILE)
	CALL READSCF(SCFFILE)
	CALL READSTR(STRFILE)
	PRINT*,' X1,X2,X3, set-up plane points ???'
	READ(5,*)X1,X2,X3
	PRINT*,' NDIV1,NDIV2 ???'
	READ(5,*)ND1,ND2
C  DEFINE PLANE
	RX=SQRT((X2(1)-X1(1))**2+(X2(2)-X1(2))**2+(X2(3)-X1(3))**2)
	RY=SQRT((X3(1)-X1(1))**2+(X3(2)-X1(2))**2+(X3(3)-X1(3))**2)
	STEPX=RX/ND1
	STEPY=RY/ND2
C  DEFINE SPLINE COEFFICIENTS
	DO 50 IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO 40 L=0,ILS(ISORT)
	DO 30 M=-L,L
	LM=L*(L+1)+1+M
		FRE=0.D0
		FIM=0.D0
		DO 10 IRAD=0,NRAD(ISORT)
		FUNR1(IRAD,LM,IATOM)=DREAL(FUN(IRAD,LM,IATOM))
		FUNI1(IRAD,LM,IATOM)=DIMAG(FUN(IRAD,LM,IATOM))
		FRE=FRE+FUNR1(IRAD,LM,IATOM)*FUNR1(IRAD,LM,IATOM)
		FIM=FIM+FUNI1(IRAD,LM,IATOM)*FUNI1(IRAD,LM,IATOM)
  10		CONTINUE
		DO 20 IRAD=0,NSHE(ISORT)+1
		FUNR2(IRAD,LM,IATOM)=DREAL(FUNINT(IRAD,LM,IATOM))
		FUNI2(IRAD,LM,IATOM)=DIMAG(FUNINT(IRAD,LM,IATOM))
  20		CONTINUE
	CALL SPLKFF(NRAD(ISORT)+1,R(0,ISORT),FUNR1(0,LM,IATOM)
     & ,WXR1(0,LM,IATOM),WYR1(0,LM,IATOM),WZR1(0,LM,IATOM))
	CALL SPLKFF(NRAD(ISORT)+1,R(0,ISORT),FUNI1(0,LM,IATOM)
     & ,WXI1(0,LM,IATOM),WYI1(0,LM,IATOM),WZI1(0,LM,IATOM))
	CALL SPLKFF(NSHE(ISORT)+2,RINT(0,ISORT)
     & ,FUNR2(0,LM,IATOM),WXR2(0,LM,IATOM),WYR2(0,LM,IATOM),WZR2(0,LM,
     &  IATOM))
	CALL SPLKFF(NSHE(ISORT)+2,RINT(0,ISORT)
     & ,FUNI2(0,LM,IATOM),WXI2(0,LM,IATOM),WYI2(0,LM,IATOM),WZI2(0,LM,
     &  IATOM))
  30	CONTINUE
  40	CONTINUE
  50	CONTINUE
C
	DO 60 IATOM=1,NATOM
	SW1(IATOM)=SW(IS(IATOM))
  60	CONTINUE
	CALL NETSURF(X1,X2,X3,A,B,C,NATOM,TAU,ND1,ND2,PLNET,
     &  VNET,IATREF,SW1)
	NX=ND1+1
	NY=ND2+1
C
	WRITE(1,1010)NX,NY
	DO 100 IX=0,ND1
	X(IX)=IX*STEPX
	DO 90 IY=0,ND2
	Y(IY)=IY*STEPY
	IATOM=IATREF(IX,IY)
	ISORT=IS(IATOM)
	XX=VNET(1,IX,IY)*PAR
	YY=VNET(2,IX,IY)*PAR
	ZZ=VNET(3,IX,IY)*PAR
	RR=DSQRT(XX*XX+YY*YY+ZZ*ZZ)
	Z(IX,IY)=0
	IF(RR.GE.1.D-10)THEN
	CALL SPHHARM(XX/RR,YY/RR,ZZ/RR,ILS(ISORT),YLM)
	DO 80 L=0,ILS(ISORT)
	DO 70 M=-L,L
	LM=L*(L+1)+1+M
	IF(RR.LE.SMT(ISORT)) THEN
	ZRR=SPLPNT(NRAD(ISORT)+1,RR,R(0,ISORT),FUNR1(0,LM,IATOM)
     &  ,WXR1(0,LM,IATOM),WYR1(0,LM,IATOM),WZR1(0,LM,IATOM))
	ZRI=SPLPNT(NRAD(ISORT)+1,RR,R(0,ISORT),FUNI1(0,LM,IATOM)
     &  ,WXI1(0,LM,IATOM),WYI1(0,LM,IATOM),WZI1(0,LM,IATOM))
	ELSE
	ZRR=SPLPNT(NSHE(ISORT)+2,RR,RINT(0,ISORT),FUNR2(0,LM,IATOM)
     &  ,WXR2(0,LM,IATOM),WYR2(0,LM,IATOM),WZR2(0,LM,IATOM))
	ZRI=SPLPNT(NSHE(ISORT)+2,RR,RINT(0,ISORT),FUNI2(0,LM,IATOM)
     &  ,WXI2(0,LM,IATOM),WYI2(0,LM,IATOM),WZI2(0,LM,IATOM))
	ENDIF
	Z(IX,IY)=Z(IX,IY)+DCMPLX(ZRR,ZRI)*(0.D0,1.D0)**L*YLM(LM)
  70	CONTINUE
  80	CONTINUE
	ELSE
C	Z(IX,IY)=FUN(0,1,IATOM)/SQPI4
	Z(IX,IY)=0.D0
	ENDIF
	WRITE(1,1020)X(IX),Y(IY),Z(IX,IY)
  90    CONTINUE
 100	CONTINUE
1000	FORMAT($,1X,A)
1001	FORMAT(A)
1010	FORMAT(1X,I3,3X,I3)
1020	FORMAT(1X,G14.7,3X,G14.7,3X,G14.7)
	END




	SUBROUTINE READINI(INIFILE)
************************************************************
*  <READINI> reads control parameters,atomic stucture data *
*  iterative procedures limits and accuracy parameters     *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILS(NSORTMAX),NSHE(NSORTMAX)
     &   ,NPOL(0:NSORTMAX)
	DIMENSION Z(NSORTMAX),ZCORE(NSORTMAX),SROU(NSORTMAX)
	CHARACTER*60 INIFILE,TXTEL(NSORTMAX)*10
	COMMON /PARAM/   NSORT,IS,ILS,NATOM,NSPIN
	COMMON /POTCOM/  SWZ,SMT(NSORTMAX)
	COMMON /LATPAR/  PAR
	COMMON /INTMESH/ NSHE,NPOL,SROU
	COMMON /SRFINP/  SW(NSORTMAX)
	COMMON /TXTEL/   TXTEL
	DATA PI/3.141592653589793D0/
	OPEN(1,FILE=INIFILE,STATUS='OLD')
	DO 10 I=1,13
	READ(1,*)
  10	CONTINUE
	READ(1,*)NATOM,NSORT,NSPIN
	READ(1,*)PAR
	READ(1,*)(IS(I),I=1,NATOM)
	READ(1,*)NKAP
	DO 40 ISORT=1,NSORT
	READ(1,1000)TXTEL(ISORT)
	READ(1,*)Z(ISORT),ZCORE(ISORT)
	READ(1,*)SMT(ISORT),SROU(ISORT),SW(ISORT)
	READ(1,*)LMT,LMB,ILS(ISORT)
	READ(1,*)
	DO 20 IKAP=1,NKAP
	READ(1,*)
	READ(1,*)
	READ(1,*)
	READ(1,*)
	READ(1,*)
	READ(1,*)
  20	CONTINUE
	READ(1,*)
	READ(1,*)NC
	DO 30 IC=1,NC
	READ(1,*)
  30	CONTINUE
  40	CONTINUE
	CLOSE(1)
1000	FORMAT(A60)
	END


	SUBROUTINE READSCF(SCFFILE)
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	CHARACTER*60 SCFFILE
	INTEGER*4 IS(NPAT),ILS(NSORTMAX),NRAD(NSORTMAX),NSYM(NPAT)
     &   ,NSHE(NSORTMAX),NPOL(0:NSORTMAX)
	DIMENSION FUN0(0:NRADMAX,NSORTMAX,NSPINMAX)
     & 	 ,R(0:NRADMAX,NSORTMAX),RINT(0:NSHEMAX,NSORTMAX)
	COMPLEX*16 FUN(0:NRADMAX,LMMAXV,NPAT)
     & 	 ,FUNINT(0:NSHEMAX,LMMAXV,NPAT),FUNC(0:NRADMAX,NSPINMAX)
     &	 ,FUNINTC(0:NSHEMAX,NSPINMAX),F(0:NRADMAX,NSPINMAX)
     &   ,FI(0:NSHEMAX,NSPINMAX),FUNDS(3,LMMAXV,NPAT,NSPINMAX)
	COMMON /PARAM/   NSORT,IS,ILS,NATOM,NSPIN
	COMMON /INTMESH/ NSHE
	COMMON /RADMESH/ NRAD,R,RINT
	COMMON /COMFUN/  FUN,FUNINT,FUNDS,FUN0
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
	print*,'iscf=1=pot, iscf=2=den, iscf=3=mag'
	read(5,*)iscf
	IF(ISCF.EQ.1)THEN
	OPEN(1,FILE=SCFFILE,STATUS='OLD',FORM='UNFORMATTED')
	READ(1) NATOM,NSORT,(NRAD(ISORT),ISORT=1,NSORT),NSHE0,
     &  (NSYM(IATOM),IATOM=1,NATOM),(ILS(ISORT),ISORT=1,NSORT),
     &  NSPIN,(NSHE(ISORT),ISORT=1,NSORT)
	IF(NSHE0.NE.0)STOP'SCFFILE IS TOO OLD, CANNOT BE USED'
	DO 40 IATOM=1,NATOM
	ISORT=IS(IATOM)
	IF(NSHE(ISORT).GT.NSHEMAX)STOP'# OF RADIAL POINTS IS TOO LARGE,
     &  INCREASE NSHEMAX IN PARAM.DAT'
	IF(NRAD(ISORT).GT.NRADMAX)STOP'# OF RADIAL POINTS IS TOO LARGE,
     &  INCREASE NRADMAX IN PARAM.DAT'
	DO 30 ISYM=1,NSYM(IATOM)
	READ(1)LM
	READ(1)((F(I,ISPIN),I=0,NRAD(ISORT)),ISPIN=1,NSPIN)
	READ(1)((FI(I,ISPIN),I=0,NSHE(ISORT)+1),ISPIN=1,NSPIN)
	READ(1)((FUNDS(I,LM,IATOM,ISPIN),I=1,3),ISPIN=1,NSPIN)
	DO 10 I=0,NRAD(ISORT)
	FUN(I,LM,IATOM)=(F(I,1)+F(I,NSPIN))/2.D0*NSPIN
  10	CONTINUE
	DO 20 I=0,NSHE(ISORT)+1
	FUNINT(I,LM,IATOM)=(FI(I,1)+FI(I,NSPIN))/2.D0*NSPIN
  20	CONTINUE
  30	CONTINUE
  40	CONTINUE
	DO 50 ISORT=1,NSORT
	READ(1) (R(I,ISORT),I=0,NRAD(ISORT))
	READ(1) (RINT(I,ISORT),I=0,NSHE(ISORT)+1)
 	READ(1)((FUN0(I,ISORT,ISPIN),I=0,NRAD(ISORT)),ISPIN=1,NSPIN)
  50	CONTINUE
	CLOSE(1)
	ELSEIF(ISCF.EQ.2.OR.ISCF.EQ.3)THEN
	OPEN(1,FILE=SCFFILE,STATUS='OLD',FORM='UNFORMATTED')
	READ(1) NATOM,NSORT,(NRAD(ISORT),ISORT=1,NSORT),NSHE0,NLIB
     &  ,(NSYM(IATOM),IATOM=1,NATOM),(ILS(ISORT),ISORT=1,NSORT),
     &  NSPIN,(NSHE(ISORT),ISORT=1,NSORT) 
	IF(NSHE0.NE.0)STOP'SCFFILE IS TOO OLD, CANNOT BE USED'
	DO 110 IATOM=1,NATOM
	ISORT=IS(IATOM)
	IF(NSHE(ISORT).GT.NSHEMAX)STOP'# OF RADIAL POINTS IS TOO LARGE,
     &  INCREASE NSHEMAX IN PARAM.DAT'
	IF(NRAD(ISORT).GT.NRADMAX)STOP'# OF RADIAL POINTS IS TOO LARGE,
     &  INCREASE NRADMAX IN PARAM.DAT'
	READ(1) (R(I,ISORT),I=0,NRAD(ISORT))
	READ(1) (RINT(I,ISORT),I=0,NSHE(ISORT)+1)
 	READ(1) 
	DO 100 ISYM=1,NSYM(IATOM)
	READ(1)LM
	READ(1)((F(I,ISPIN),I=0,NRAD(ISORT)),ISPIN=1,NSPIN)
	READ(1)((FI(I,ISPIN),I=0,NSHE(ISORT)+1),ISPIN=1,NSPIN)
	READ(1)
	READ(1)((FUNC(I,ISPIN),I=0,NRAD(ISORT)),ISPIN=1,NSPIN)
	READ(1)((FUNINTC(I,ISPIN),I=0,NSHE(ISORT)+1),ISPIN=1,NSPIN)
	DO 70 I=0,NRAD(ISORT)
	DO 60 ISPIN=1,NSPIN
	F(I,ISPIN)=F(I,ISPIN)-FUNC(I,ISPIN)
  60	CONTINUE
	IF(ISCF.EQ.2)FUN(I,LM,IATOM)=(F(I,1)+F(I,NSPIN))/2.D0*NSPIN
	IF(ISCF.EQ.3)FUN(I,LM,IATOM)=(F(I,1)-F(I,NSPIN))
  70	CONTINUE
	DO 90 I=0,NSHE(ISORT)+1
	DO 80 ISPIN=1,NSPIN
	FI(I,ISPIN)=FI(I,ISPIN)-FUNINTC(I,ISPIN)
  80	CONTINUE
	IF(ISCF.EQ.2)
     &  FUNINT(I,LM,IATOM)=(FI(I,1)+FI(I,NSPIN))/2.D0*NSPIN
	IF(ISCF.EQ.3)FUNINT(I,LM,IATOM)=(FI(I,1)-FI(I,NSPIN))
  90	CONTINUE
 100	CONTINUE
	READ(1)
	READ(1)
 	READ(1)
 	READ(1)
 	READ(1)
 110	CONTINUE
	CLOSE(1)
	ENDIF
	END

        SUBROUTINE READSTR(STRFILE)
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        CHARACTER STRFILE*60,TXT*72,STRING(80)*1
        INTEGER IS(NPAT),ILS(NSORTMAX)
        DIMENSION RBASR(3,3),TAUR(3,NPAT),BASR(3),BBASR(3,3),ORTH(2:3)
     &    ,GBAS(3,3),RBAS(3,3),BBAS(3,3),TAU(3,NPAT),STRAIN(3,3,2)
     &    ,RSTN(3,3),TAU0(3,NPAT),TAU0R(3,NPAT)
        COMMON /LATTICE/RBAS,GBAS                       !!! from init
        COMMON /MANSTR/ ISTRAIN,IBAS,IBZ,ICALC          !!! from init
        COMMON /BASIS/  TAU                             !!! from init
        COMMON /BASIS0/ TAU0                            !!! from init
        COMMON /PARAM/  NSORT,IS,ILS,NATOM              !!! from init
        COMMON /LATPAR/ PAR,ORTH,OMEGAC,STRAIN          !!! from init
	COMMON /SRFINP/ SW(NSORTMAX),NDIV1,NDIV2,ACCU   !!! for srfmsh
        COMMON /UNIT/   IUN                             !!! from init
        DATA PI/3.141592653589793D0/
        OPEN(UNIT=1,FILE=STRFILE,STATUS='OLD')
        READ(1,*)
        READ(1,1001)TXT
        READ(1,*) NATOM0,ORTH
        READ(1,*) IBAS,IBZ,ICALC,ISTRAIN
        READ(1,*) NDIV1,NDIV2
        READ(1,*) NVECMX,ALPHA
        IF(NATOM0.NE.NATOM)STOP'<READSTR>: # OF ATOMS MISMATCHES
     &  IN STRFILE, CHECK IT'
        READ(1,1000)TXT
        DO 10 IVEC=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(RBASR(I,IVEC),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,RBASR(1,IVEC),3)
        ENDIF
  10    CONTINUE
        READ(1,1000)TXT
        DO 15 IATOM=1,NATOM
        IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
        IF(ICALC.NE.1)THEN
        READ(1,*)(TAU0R(I,IATOM),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,TAU0R(1,IATOM),3)
        ENDIF
        ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
        IF(ICALC.NE.1)THEN
        READ(1,*)(BASR(I),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        ENDIF
        TAU0R(1,IATOM)=BASR(1)*RBASR(1,1)
     &                +BASR(2)*RBASR(1,2)
     &                +BASR(3)*RBASR(1,3)
        TAU0R(2,IATOM)=BASR(1)*RBASR(2,1)
     &                +BASR(2)*RBASR(2,2)
     &                +BASR(3)*RBASR(2,3)
        TAU0R(3,IATOM)=BASR(1)*RBASR(3,1)
     &                +BASR(2)*RBASR(3,2)
     &                +BASR(3)*RBASR(3,3)
        ENDIF
  15    CONTINUE
        READ(1,1000)TXT
        DO 20 IATOM=1,NATOM
        IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
        IF(ICALC.NE.1)THEN
        READ(1,*)(TAUR(I,IATOM),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,TAUR(1,IATOM),3)
        ENDIF
        ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
        IF(ICALC.NE.1)THEN
        READ(1,*)(BASR(I),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        ENDIF
        TAUR(1,IATOM)=BASR(1)*RBASR(1,1)
     &               +BASR(2)*RBASR(1,2)
     &               +BASR(3)*RBASR(1,3)
        TAUR(2,IATOM)=BASR(1)*RBASR(2,1)
     &               +BASR(2)*RBASR(2,2)
     &               +BASR(3)*RBASR(2,3)
        TAUR(3,IATOM)=BASR(1)*RBASR(3,1)
     &               +BASR(2)*RBASR(3,2)
     &               +BASR(3)*RBASR(3,3)
        ENDIF
  20    CONTINUE
        READ(1,1000)TXT
        DO 30 I=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(STRAIN(I,J,1),J=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        STRAIN(I,1,1)=BASR(1)
        STRAIN(I,2,1)=BASR(2)
        STRAIN(I,3,1)=BASR(3)
        ENDIF
  30    CONTINUE
C  SET RECIPROCAL STRAIN MATRIX: S*S^(-1)=1
        CALL CROSS(RSTN(1,1),STRAIN(1,2,1),STRAIN(1,3,1))
        CALL CROSS(RSTN(1,2),STRAIN(1,3,1),STRAIN(1,1,1))
        CALL CROSS(RSTN(1,3),STRAIN(1,1,1),STRAIN(1,2,1))
        W=STRAIN(1,1,1)*RSTN(1,1)
     &   +STRAIN(2,1,1)*RSTN(2,1)
     &   +STRAIN(3,1,1)*RSTN(3,1)
        IF(ABS(W).LE.1.D-10)STOP'<READSTR>:: WRONG STRAIN, DET=0'
        DO 40 I=1,3
        STRAIN(1,I,2)=RSTN(I,1)/W
        STRAIN(2,I,2)=RSTN(I,2)/W
        STRAIN(3,I,2)=RSTN(I,3)/W
  40    CONTINUE
        READ(1,*)
        READ(1,*)
        READ(1,1000)TXT
        DO 50 IVEC=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(BBASR(I,IVEC),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BBASR(1,IVEC),3)
        ENDIF
  50    CONTINUE
C  ACCOUNT FOR ORTHOROMBICITY PARAMETERS
        DO 90 I=2,3
        DO 70 IVEC=1,3
        RBASR(I,IVEC)=RBASR(I,IVEC)*ORTH(I)
        BBASR(I,IVEC)=BBASR(I,IVEC)/ORTH(I)
  70    CONTINUE
        DO 80 IATOM=1,NATOM
        TAU0R(I,IATOM)=TAU0R(I,IATOM)*ORTH(I)
        TAU R(I,IATOM)=TAU R(I,IATOM)*ORTH(I)
  80    CONTINUE
  90    CONTINUE
C  APPLY STRAIN MATRIX FOR TRANSLATIONS:  R'=S*R
        DO 150 IVEC=1,3
        DO 150 I=1,3
        RBAS(I,IVEC)=0.D0
        DO 140 J=1,3
        RBAS(I,IVEC)=RBAS(I,IVEC)+STRAIN(I,J,1)*RBASR(J,IVEC)
 140    CONTINUE
 150    CONTINUE
C  APPLY STRAIN FOR BASIS VECTORS:  T'=S*T
        DO 170 IATOM=1,NATOM
        DO 170 I=1,3
        TAU (I,IATOM)=0.D0
        TAU0(I,IATOM)=0.D0
        DO 160 J=1,3
        TAU (I,IATOM)=TAU (I,IATOM)+STRAIN(I,J,1)*TAU R(J,IATOM)
        TAU0(I,IATOM)=TAU0(I,IATOM)+STRAIN(I,J,1)*TAU0R(J,IATOM)
 160    CONTINUE
 170    CONTINUE
C  APPLY INVERSE STRAIN FOR BRILLOUIN ZONE: BZ'=BZ*S^(-1)
        DO 190 IVEC=1,3
        DO 190 I=1,3
        BBAS(I,IVEC)=0.D0
        DO 180 J=1,3
        BBAS(I,IVEC)=BBAS(I,IVEC)+BBASR(J,IVEC)*STRAIN(J,I,2)
 180    CONTINUE
 190    CONTINUE
C  SET RECIPROCAL LATTICE VECTORS WITHOUT 2*PI
        CALL CROSS(GBAS(1,1),RBAS(1,2),RBAS(1,3))
        CALL CROSS(GBAS(1,2),RBAS(1,3),RBAS(1,1))
        CALL CROSS(GBAS(1,3),RBAS(1,1),RBAS(1,2))
        W=RBAS(1,1)*GBAS(1,1)
     &   +RBAS(2,1)*GBAS(2,1)
     &   +RBAS(3,1)*GBAS(3,1)
        DO 230 I=1,3
        GBAS(I,1)=GBAS(I,1)/W
        GBAS(I,2)=GBAS(I,2)/W
        GBAS(I,3)=GBAS(I,3)/W
 230    CONTINUE
        OMEGAC=ABS(W)*PAR**3
C  SET BRILLOUIN ZONE TO GBAS IF REQUIRED
        IF(IBZ.EQ.1)THEN
        DO 240 I=1,3
        BBAS(I,1)=GBAS(I,1)
        BBAS(I,2)=GBAS(I,2)
        BBAS(I,3)=GBAS(I,3)
 240    CONTINUE
        ENDIF
1000    FORMAT(A)
1001    FORMAT(/A)
1010    FORMAT(2(1X,A1))
1020    FORMAT(80A1)
        END


        SUBROUTINE CROSS(A,B,C)
**********************************************************
*    Cross product (AX,AY,AZ)=(BX,BY,BZ)*(CX,CY,CZ)      *
**********************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION A(3),B(3),C(3)
        A(1)=B(2)*C(3)-B(3)*C(2)
        A(2)=B(3)*C(1)-B(1)*C(3)
        A(3)=B(1)*C(2)-B(2)*C(1)
        END



	subroutine netsurf(x1,x2,x3,a,b,c,natom,tau,nd1,nd2,plnet,vnet,
     &  		   iatref,wr)
c
c	x1,x2,x3 boundary points
c	a,b,c    translations
c	tau	 basis set
c	nd1,nd2	 ndiv for square net
c	plnet 	 square output net
c	vnet     reference net
c	iatref	 reference centre
c
	include 'PARAM.DAT'
	PARAMETER (ndrmax=500)
	implicit real*8 (a-h,o-z)
	integer iatref(ndrmax+1,ndrmax+1),ia(8*npat)
	dimension x1(3),x2(3),x3(3),a(3),b(3),c(3),tau(3,npat),tu(3,npat)
     &  	 ,vnet(3,ndrmax+1,ndrmax+1),plnet(3,ndrmax+1,ndrmax+1)
     &  	 ,site(3,npat*8),rmt(npat),wr(npat),xw(3)
c
c input check:
	sc=0
	do i=1,3
	sc=(x2(i)-x1(i))*(x3(i)-x1(i))+sc
	enddo
	if(abs(sc).ge.1.d-10) stop'STOP FROM "NETSURF": NON SQUARE NET'
c square net generator:
	do i=1,nd1+1
	do j=1,nd2+1
	do k=1,3
	plnet(k,i,j)=x1(k)+(x2(k)-x1(k))/dble(nd1)*dble(i-1)+
     &  	     (x3(k)-x1(k))/dble(nd2)*dble(j-1)
	enddo
	enddo
	enddo
c
c weight searching:
	call nasos(wr,rmt,a,b,c,tau,natom)
c
	do i=1,natom
	call reduc(a,b,c,tau(1,i),tu(1,i),1)
	enddo
c site generation:
	nv=0
	do i=-1,0
	do j=-1,0
	do k=-1,0
		do iat=1,natom
		nv=nv+1
		ia(nv)=iat
			do ik=1,3
			site(ik,nv)=a(ik)*i+b(ik)*j+c(ik)*k+tu(ik,iat)
			enddo
		enddo
	enddo
	enddo
	enddo
c classification on site:
	do i=1,nd1+1
	do j=1,nd2+1
	call reduc(a,b,c,plnet(1,i,j),xw,0)
	rmin=(xw(1)-site(1,1))**2+(xw(2)-site(2,1))**2+
     &      (xw(3)-site(3,1))**2-rmt(ia(1))**2
	IATREF(I,J)=IA(1)
	vnet(1,i,j)=xw(1)-site(1,1)
	vnet(2,i,j)=xw(2)-site(2,1)
	vnet(3,i,j)=xw(3)-site(3,1)
		do iv=2,nv
	rmin0=(xw(1)-site(1,IV))**2+(xw(2)-site(2,IV))**2+
     &      (xw(3)-site(3,IV))**2-rmt(ia(iv))**2
	if(rmin0.lt.rmin) then
	rmin=rmin0
	iatref(i,j)=ia(iv)
	vnet(1,i,j)=xw(1)-site(1,IV)
	vnet(2,i,j)=xw(2)-site(2,IV)
	vnet(3,i,j)=xw(3)-site(3,IV)
	endif
		enddo
	enddo
	enddo
	return
	end
