	SUBROUTINE GRADFINT(FUN,GFUN,MY,LMF,NSHE,R,S,SR)
************************************************************
*  Computes gradient of the function expanded in spherical *
*  harmonics in the interstitial region.                   *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	COMPLEX*16 FUN(0:NSHEMAX,LMMAXV),GFUN(0:NSHEMAX,LMMAXV)
     &   ,DFUNDR(0:NRADMAX),CGNT
	DIMENSION C(0:LMAXV+1,LMMAXV1,LMMAXV1),R(0:NRADMAX)
        COMMON /GAUNT/  C                                   !!! from gaunt
	DATA PI/3.141592653589793D0/
        SQPI43=SQRT(4.D0*PI/3.D0)
        DO L=0,LMF
        DO M=-L,L
        LM=L*(L+1)+M+1
        DO IRAD=0,NSHE+1
        GFUN(IRAD,LM)=(0.D0,0.D0)
        ENDDO
        ENDDO
        ENDDO
        DO L=0,LMF                       !!! over l
        DO M=-L,L                        !!! over m
        LM=L*(L+1)+M+1
        IF(L.GT.0.AND.(L-1).GE.ABS(M-MY))THEN
        LMY=L*(L-1)+M-MY+1
        CGNT=C(0,LM,LMY)*SQPI43*(0.D0,-1.D0)
	CALL CDERIV2(FUN(0,LMY),DFUNDR(0),NSHE,R(0),S,SR)
        DO IRAD=0,NSHE+1
        GFUN(IRAD,LM)=GFUN(IRAD,LM)+CGNT*(DFUNDR(IRAD)-
     &  DBLE(L-1)/R(IRAD)*FUN(IRAD,LMY))
        ENDDO
        ENDIF
        IF(L.LT.LMF)THEN
        LMY=(L+1)*(L+2)+M-MY+1
        CGNT=C(0,LM,LMY)*SQPI43*(0.D0,1.D0)
	CALL CDERIV2(FUN(0,LMY),DFUNDR(0),NSHE,R(0),S,SR)
        DO IRAD=0,NSHE+1
        GFUN(IRAD,LM)=GFUN(IRAD,LM)+CGNT*(DFUNDR(IRAD)+
     &  DBLE(L+2)/R(IRAD)*FUN(IRAD,LMY))
        ENDDO
        ENDIF
        GFUN(0,LM)=GFUN(1,LM)
        ENDDO                            !!! over m
        ENDDO                            !!! over l
	END
