	SUBROUTINE MIXRO1(ITER,EXIT)
*****************************************
*   Admixture in the main SCF loop      *
*****************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &    ,NRAD(NSORTMAX),ICOR(NSORTMAX),NTYPE(NSORTMAX)
     &    ,NSHE(NSORTMAX),NPOL(0:NSORTMAX)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,ROOLD(0:NRADMAX,NSPINMAX),RODSOLD(3,NSPINMAX)
     &    ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
     &    ,WORK1(0:NRADMAX),WORK2(0:NRADMAX)
     &    ,ROC(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,ROINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,ROCINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,ROINTOLD(0:NSHEMAX,NSPINMAX)
     &    ,ROCOLD(0:NRADMAX,NSPINMAX)
     &    ,ROCINTOL(0:NSHEMAX,NSPINMAX)
     &    ,ROINP,ROOUT,RONEW,AMINP,AMOUT,AMNEW
     &    ,AMTOT(NSYMMAX,NPAT,NSPINMAX),DELRHO
     &    ,TCH(NSYMMAX,NPAT,2,NSPINMAX)
	DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX)
     &    ,WEIGHT(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &    ,Z(NSORTMAX),ZCOR(NSORTMAX),SROU(NSORTMAX)
     &    ,RINT(0:NSHEMAX,NSORTMAX)
	CHARACTER*10 TXTEL(NSORTMAX)
        CHARACTER*60 INIFILE,CONFILE,SRFFILE,KOVFILE,PTNFILE,WFFILE
     &   ,TMPFILE,POTFILE,SCFFILE,OUTFILE,BNDFILE,DOSFILE
	LOGICAL SYM(LMMAXV,NPAT),EXIT
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from init
	COMMON /MIXRHO1/ADMIX1,ADMIN,ADMAX,KEY,ADMOPT        !!! from mixro1
        COMMON /MIXMAG1/ADMSPN,ASMIN,ASMAX,KSP,ADSPIN        !!! from mixro1
        COMMON /MIXBROY/LBROY,IBROY,ADMIXB,ADMIXH            !!! from mixrob
	COMMON /DENS/   RO,ROVALDS,ROC,ROINT,ROCINT          !!! from rofull
	COMMON /SYMMLM/ SYM,LMSYM                            !!! from symmlm
	COMMON /COR1/   ICOR                                 !!! from init
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT                   !!! from radmsh
	COMMON /MULTRO/ Z,ZCOR,TCH,AMTOT                     !!! from multro
        COMMON /OUT1/   ISS,ISRF,IKOV,IWF,ITMP,IBND,IPOT
     &                 ,IPTN,IDOS,ISCF,IOUT
        COMMON /OUT2/   CONFILE,SRFFILE,KOVFILE, WFFILE,TMPFILE,BNDFILE
     &                 ,POTFILE,PTNFILE,DOSFILE,SCFFILE,OUTFILE
	COMMON /INTMESH/NSHE,NPOL,SROU,RINT                  !!! from intmsh
	COMMON /ACCU/   EPSTOT,EPSRHO,EPSMAG                 !!! from nmtdat
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /TXTEL/  TXTEL                                !!! from init
	COMMON /UNIT/   IUN,IUT,IUR                          !!! from init
	DATA PI/3.141592653589793D0/
	IF(ITER.EQ.0)RETURN
C CALCULATE NEW ABSOLUTE CHARGE TRANFERE AND MAGNETISATION
	QTOT=0.D0
	ATOT=0.D0
	DO 10 IATOM=1,NATOM
	QTOT=QTOT+ABS(AMTOT(1,IATOM,1)+AMTOT(1,IATOM,NSPIN))/
     &  2.D0*DFLOAT(NSPIN)
	ATOT=ATOT+ABS(AMTOT(1,IATOM,1)-AMTOT(1,IATOM,NSPIN))
	NTYPE(IS(IATOM))=0
  10	CONTINUE
C FIND OPTIMAL ADMIXTURE
        IF(LBROY.LT.0)THEN
        CALL PRATTC(QTOT,ITER,KEY,ADMIX1,ADMIN,ADMAX,ADMOPT)
        CALL PRATTM(ATOT,ITER,KSP,ADMSPN,ASMIN,ASMAX,ADSPIN)
        ELSEIF(LBROY.GE.0)THEN
C SET INPUT ADMIXTURE IF BROYDEN IS ON.
        ADMOPT=ADMIXH
        ADSPIN=ADMIXH
        ENDIF
        IF(ITER.EQ.1)ADMCOR=1.D0
        IF(ITER.NE.1)ADMCOR=ADMOPT
C OPEN FILE WITH THE OLD CHARGE DENSITY
        OPEN(3,FILE=SCFFILE,STATUS='OLD',FORM='UNFORMATTED')
	READ(3)NATOM,NSORT  !!! hope they are right 
C DO OVER ALL ATOMS IN CELL
	DZ=0.D0
	DM=0.D0
	DO 120 IATOM=1,NATOM                      !!! over atoms in cell
	ISORT=IS(IATOM)
	DO 20 IREAD=1,3
  20 	READ(3)             !!! skip three lines  !!!
	DO 110 L=0,ILSV(ISORT)                    !!! over l
        DO 110 M=-L,L                             !!! over m
        LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN                     !!! for non-zero components
	ISYM=LMSYM(LM,IATOM)
	READ(3) L0M0
	IF(L0M0.NE.LM)STOP'<MIXRO>: L0M0.NE.LM'
        READ(3)((ROOLD(I,ISPIN),I=0,NRAD(IS(IATOM))),ISPIN=1,NSPIN)
        READ(3)((ROINTOLD(I,ISPIN),I=0,NSHE(ISORT)+1),ISPIN=1,NSPIN)
        READ(3)((RODSOLD(I,ISPIN),I=1,3),ISPIN=1,NSPIN)
        READ(3)((ROCOLD(I,ISPIN),I=0,NRAD(ISORT)),ISPIN=1,NSPIN)
        READ(3)((ROCINTOL(I,ISPIN),I=0,NSHE(ISORT)+1),ISPIN=1,NSPIN)
C DEFINE CHARGE CONVERGENCY BETWEEN ITERATIONS
	DO 60 IRAD=0,NRAD(ISORT)
        DELRHO=(RO(IRAD,ISYM,IATOM,1)+RO(IRAD,ISYM,IATOM,NSPIN))/
     &  2.D0*DFLOAT(NSPIN)-(ROOLD(IRAD,1)+ROOLD(IRAD,NSPIN))/
     &  2.D0*DFLOAT(NSPIN)
	WORK1(IRAD)=WEIGHT(IRAD,IS(IATOM))*DCONJG(DELRHO)*
     &  DELRHO/4.D0/PI
  60 	CONTINUE
	CALL CQD(H(IS(IATOM)),WORK1,WORK2,NRAD(ISORT)+1)
	DZ=DZ+WORK2(NRAD(ISORT))
	DO 70 IRAD=0,NRAD(ISORT)
     	DELRHO=(RO(IRAD,ISYM,IATOM,1)-RO(IRAD,ISYM,IATOM,NSPIN))-(
     &  ROOLD(IRAD,1)-ROOLD(IRAD,NSPIN))
	WORK1(IRAD)=WEIGHT(IRAD,IS(IATOM))*DCONJG(DELRHO)*
     &  DELRHO/4.D0/PI
  70	CONTINUE
	CALL CQD(H(IS(IATOM)),WORK1,WORK2,NRAD(ISORT)+1)
	DM=DM+WORK2(NRAD(ISORT))
C ADMIX NEW CHARGE DENSITY WITH THE OLD ONE
	DO 80 IRAD=0,NRAD(ISORT)
C 1. VALENCE DENSITY WITHIN MT-SPHERES
        IF(L.GT.LBROY)THEN                       !!! for l>l_broy
	ROOUT=(RO(IRAD,ISYM,IATOM,1)+RO(IRAD,ISYM,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
	ROINP=(ROOLD(IRAD,1)+ROOLD(IRAD,NSPIN))/2.D0*DBLE(NSPIN)
	RONEW=ADMOPT*ROOUT+(1.D0-ADMOPT)*ROINP
	AMOUT=(RO(IRAD,ISYM,IATOM,1)-RO(IRAD,ISYM,IATOM,NSPIN))
	AMINP=(ROOLD(IRAD,1)-ROOLD(IRAD,NSPIN))
	AMNEW=ADSPIN*AMOUT+(1.D0-ADSPIN)*AMINP
	RO(IRAD,ISYM,IATOM,1)=(RONEW+AMNEW)/DBLE(NSPIN)
	RO(IRAD,ISYM,IATOM,NSPIN)=(RONEW-AMNEW)/DBLE(NSPIN)
        ENDIF                                   !!! for l>l_broy
	IF(L.LE.LBROY)THEN
	DO 75 ISPIN=1,NSPIN
	RO(IRAD,ISYM,IATOM,ISPIN)=RO(IRAD,ISYM,IATOM,ISPIN)-
     &  ROC(IRAD,ISYM,IATOM,ISPIN)
  75	CONTINUE
	ENDIF
C 2. CORE DENSITY AND MAGNETIZATION WITHIN MT-SPHERES
	ROOUT=(ROC(IRAD,ISYM,IATOM,1)+ROC(IRAD,ISYM,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
	ROINP=(ROCOLD(IRAD,1)+ROCOLD(IRAD,NSPIN))/
     &  2.D0*DBLE(NSPIN)
	RONEW=ADMCOR*ROOUT+(1.D0-ADMCOR)*ROINP
	AMOUT=(ROC(IRAD,ISYM,IATOM,1)-ROC(IRAD,ISYM,IATOM,NSPIN))
	AMINP=(ROCOLD(IRAD,1)-ROCOLD(IRAD,NSPIN))
	AMNEW=ADMCOR*AMOUT+(1.D0-ADMCOR)*AMINP
	ROC(IRAD,ISYM,IATOM,1)=(RONEW+AMNEW)/DBLE(NSPIN)
	ROC(IRAD,ISYM,IATOM,NSPIN)=(RONEW-AMNEW)/DBLE(NSPIN)
C 3. ADD CORE DENSITY TO THE VALENCE DENSITY
	IF(L.LE.LBROY)THEN
	DO 77 ISPIN=1,NSPIN
	RO(IRAD,ISYM,IATOM,ISPIN)=RO(IRAD,ISYM,IATOM,ISPIN)+
     &  ROC(IRAD,ISYM,IATOM,ISPIN)
  77	CONTINUE
	ENDIF
  80	CONTINUE
	DO 90 IRAD=0,NSHE(ISORT)+1
        IF(LBROY.LT.0)THEN                       !!! if Broyden is off
C 3. VALENCE CHAGRE AND MAGNETIZATION IN THE INTERSTITIALS
	ROOUT=(ROINT(IRAD,ISYM,IATOM,1)+ROINT(IRAD,ISYM,IATOM,NSPIN))/
     &  2.D0*DFLOAT(NSPIN)
	ROINP=(ROINTOLD(IRAD,1)+ROINTOLD(IRAD,NSPIN))/
     &  2.D0*DFLOAT(NSPIN)
	RONEW=ADMOPT*ROOUT+(1.D0-ADMOPT)*ROINP
	AMOUT=(ROINT(IRAD,ISYM,IATOM,1)-ROINT(IRAD,ISYM,IATOM,NSPIN))
	AMINP=(ROINTOLD(IRAD,1)-ROINTOLD(IRAD,NSPIN))
	AMNEW=ADSPIN*AMOUT+(1.D0-ADSPIN)*AMINP
	ROINT(IRAD,ISYM,IATOM,1)=(RONEW+AMNEW)/DFLOAT(NSPIN)
	ROINT(IRAD,ISYM,IATOM,NSPIN)=(RONEW-AMNEW)/DFLOAT(NSPIN)
        ENDIF                                   !!! if Broyden is off
	IF(LBROY.GE.0)THEN
	DO 85 ISPIN=1,NSPIN
	ROINT(IRAD,ISYM,IATOM,ISPIN)=ROINT(IRAD,ISYM,IATOM,ISPIN)-
     &  ROCINT(IRAD,ISYM,IATOM,ISPIN)
  85	CONTINUE
	ENDIF
C 4. CORE CHARGE AND MAGNETIZATION IN THE INTERSTITIALS
	ROOUT=(ROCINT(IRAD,ISYM,IATOM,1)+ROCINT(IRAD,ISYM,IATOM,NSPIN))/
     &  2.D0*DFLOAT(NSPIN)
	ROINP=(ROCINTOL(IRAD,1)+ROCINTOL(IRAD,NSPIN))/
     &  2.D0*DFLOAT(NSPIN)
	RONEW=ADMCOR*ROOUT+(1.D0-ADMCOR)*ROINP
	AMOUT=(ROCINT(IRAD,ISYM,IATOM,1)-ROCINT(IRAD,ISYM,IATOM,NSPIN))
	AMINP=(ROCINTOL(IRAD,1)-ROCINTOL(IRAD,NSPIN))
	AMNEW=ADMCOR*AMOUT+(1.D0-ADMCOR)*AMINP
	ROCINT(IRAD,ISYM,IATOM,1)=(RONEW+AMNEW)/DFLOAT(NSPIN)
	ROCINT(IRAD,ISYM,IATOM,NSPIN)=(RONEW-AMNEW)/DFLOAT(NSPIN)
	IF(LBROY.GE.0)THEN
	DO 87 ISPIN=1,NSPIN
	ROINT(IRAD,ISYM,IATOM,ISPIN)=ROINT(IRAD,ISYM,IATOM,ISPIN)+
     &  ROCINT(IRAD,ISYM,IATOM,ISPIN)
  87	CONTINUE
	ENDIF
  90	CONTINUE
        DO 100 ID=2,3
C 1. CHAGRE AND MAGNETIZATION DERIVATIVES AT MT-SPHERES
        ROOUT=(ROVALDS(ID,ISYM,IATOM,1)+ROVALDS(ID,ISYM,IATOM,NSPIN))/
     &  2.D0*DFLOAT(NSPIN)
        ROINP=(RODSOLD(ID,1)+RODSOLD(ID,NSPIN))/2.D0*DFLOAT(NSPIN)
        RONEW=ADMOPT*ROOUT+(1.D0-ADMOPT)*ROINP
        AMOUT=(ROVALDS(ID,ISYM,IATOM,1)-ROVALDS(ID,ISYM,IATOM,NSPIN))
        AMINP=(RODSOLD(ID,1)-RODSOLD(ID,NSPIN))
        AMNEW=ADSPIN*AMOUT+(1.D0-ADSPIN)*AMINP
        ROVALDS(ID,ISYM,IATOM,1)=(RONEW+AMNEW)/DFLOAT(NSPIN)
        ROVALDS(ID,ISYM,IATOM,NSPIN)=(RONEW-AMNEW)/DFLOAT(NSPIN)
 100    CONTINUE
        ROVALDS(1,ISYM,IATOM,1)=ROINT(0,ISYM,IATOM,1)
        ROVALDS(1,ISYM,IATOM,NSPIN)=ROINT(0,ISYM,IATOM,NSPIN)
	ENDIF                                   !!! for non-zero components
 110	CONTINUE                                !!! over lm
	DO 112 IREAD=1,4
 112	READ(3)                                 !!! skip four lines
	READ(3)
	IF(NTYPE(ISORT).EQ.1)GOTO 120
	NTYPE(ISORT)=1
 120	CONTINUE                                !!! over atoms in cell
	CLOSE(3)
	IF(ABS(DZ).LE.EPSRHO.AND.ABS(DM).LE.EPSMAG)EXIT=.TRUE.
	IF(ABS(DZ).GT.EPSRHO.OR .ABS(DM).GT.EPSMAG)EXIT=.FALSE.
        WRITE(IUN,1010)DZ,ITER
        IF(NSPIN.EQ.2)
     &  WRITE(IUN,1020)DM
        IF(IUN.NE.IUT)
     &  WRITE(IUT,1010)DZ,ITER
        IF(NSPIN.EQ.2.AND.IUN.NE.IUT)
     &  WRITE(IUT,1020)DM
        IF(LBROY.LT.0)THEN
        WRITE(IUN,1030)ADMOPT
        IF(NSPIN.EQ.2)WRITE(IUN,1040)ADSPIN
        CALL SCONVC(DZ,ITER,ADMIN,ADMAX)
        CALL SCONVM(DM,ITER,ASMIN,ASMAX)
        ENDIF
1010    FORMAT(1X,'Charge Density Self-Consistency=',G14.7,3X,I4)
1020    FORMAT(1X,'Magnetization  Self-Consistency=',G14.7)
1030    FORMAT(1X,'Charge Density Optimal Admixing=',G14.7)
1040    FORMAT(1X,'Magnetization  Optimal Admixing=',G14.7)
	END




	SUBROUTINE PRATTC(A,ITER,KEY,ADM0,ADMIN,ADMAX,ADM)
************************************************************
*  Optimal admixture choice in solving the equation:       *
*                         A=F[A]                           *
*  according to the Pratt scheme.                          *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	SAVE AINPI,AINPIP1,AOUTI
	IF(ITER.EQ.0)RETURN
C  SET INPUT AND OUTPUT VALUES
	AINPIM1=AINPI         !!! A(inp,i-1)=A(inp,i)
	AINPI=AINPIP1         !!! A(inp,i)=A(inp,i+1)
	AOUTIM1=AOUTI         !!! A(out,i-1)=A(out,i)
	AOUTI=A               !!! A(out,i)=A coming now
C  FIND OPTIMAL ADMIXTURE
	IF(ITER.EQ.1.AND.KEY.EQ.0)THEN
	ADM=ADM0              !!! input admixture in case key=0
	ELSEIF(ITER.EQ.1.AND.KEY.EQ.1)THEN
	ADM=1.D0              !!! no admixture in case key=1
	ELSEIF(ITER.EQ.2.OR.ITER.EQ.3)THEN
	ADM=ADM0              !!! constant admixture
	ELSE                  !!! optimal admixture choice
	DIF=(AOUTI-AINPI)-(AOUTIM1-AINPIM1)
	IF(ABS(DIF).LE.1.D-10)THEN
	ADM=ADM0
	ELSE
	ADM=(AINPIM1-AINPI)/(DIF+1.D-14)
	ENDIF
	ENDIF
	IF(ADM.LE.ADMIN)ADM=ADMIN
	IF(ADM.GE.ADMAX)ADM=ADMAX
C  FIND INPUT FOR THE NEXT ITERATION
	AINPIP1=AOUTI*ADM+AINPI*(1.D0-ADM) !!! A(inp,i+1)		
	END



	SUBROUTINE PRATTM(A,ITER,KEY,ADM0,ADMIN,ADMAX,ADM)
************************************************************
*  Optimal admixture choice in solving the equation:       *
*                         A=F[A]                           *
*  according to the Pratt scheme.                          *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	SAVE AINPI,AINPIP1,AOUTI
	IF(ITER.EQ.0)RETURN
C  SET INPUT AND OUTPUT VALUES
	AINPIM1=AINPI         !!! A(inp,i-1)=A(inp,i)
	AINPI=AINPIP1         !!! A(inp,i)=A(inp,i+1)
	AOUTIM1=AOUTI         !!! A(out,i-1)=A(out,i)
	AOUTI=A               !!! A(out,i)=A coming now
C  FIND OPTIMAL ADMIXTURE
	IF(ITER.EQ.1.AND.KEY.EQ.0)THEN
	ADM=ADM0              !!! input admixture in case key=0
	ELSEIF(ITER.EQ.1.AND.KEY.EQ.1)THEN
	ADM=1.D0              !!! no admixture in case key=1
	ELSEIF(ITER.EQ.2.OR.ITER.EQ.3)THEN
	ADM=ADM0              !!! constant admixture
	ELSE                  !!! optimal admixture choice
	DIF=(AOUTI-AINPI)-(AOUTIM1-AINPIM1)
	IF(ABS(DIF).LE.1.D-14)THEN
	ADM=ADM0
	ELSE
	ADM=(AINPIM1-AINPI)/(DIF+1.D-14)
	ENDIF
	ENDIF
	IF(ADM.LE.ADMIN)ADM=ADMIN
	IF(ADM.GE.ADMAX)ADM=ADMAX
C  FIND INPUT FOR THE NEXT ITERATION
	AINPIP1=AOUTI*ADM+AINPI*(1.D0-ADM) !!! A(inp,i+1)		
	END



        SUBROUTINE SCONVC(A,ITER,ADMIN,ADMAX)
************************************************************
*  Checks whether the self-consistent cycle converges.     *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION AOLD(2)
        SAVE AOLD
C  SAVE DATA OF PREVIOUS THREE ITERATIONS
        IF(ITER.EQ.1)THEN
        AOLD(1)=0.D0
        AOLD(2)=0.D0
        ELSEIF(ITER.GT.1)THEN
        AOLD(2)=AOLD(1)
        AOLD(1)=A
        ENDIF
C  CHECK WHETHER CONVERGENCY IS TAKEN PLACE
        IF(ITER.GT.3)THEN
        IF(AOLD(1).LT.AOLD(2))RETURN
        ADMIN=ADMIN/2.D0
        ADMAX=ADMAX/2.D0
        ENDIF
        END

        SUBROUTINE SCONVM(A,ITER,ADMIN,ADMAX)
************************************************************
*  Checks whether the self-consistent cycle converges.     *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION AOLD(2)
        SAVE AOLD
C  SAVE DATA OF PREVIOUS THREE ITERATIONS
        IF(ITER.EQ.1)THEN
        AOLD(1)=0.D0
        AOLD(2)=0.D0
        ELSEIF(ITER.GT.1)THEN
        AOLD(2)=AOLD(1)
        AOLD(1)=A
        ENDIF
C  CHECK WHETHER CONVERGENCY IS TAKEN PLACE
        IF(ITER.GT.3)THEN
        IF(AOLD(1).LT.AOLD(2))RETURN
        ADMIN=ADMIN/2.D0
        ADMAX=ADMAX/2.D0
        ENDIF
        END



	SUBROUTINE SMIXTCH(ITER)
*****************************************
*   Mix multipoles.                     *
*****************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
	COMPLEX*16 ROINP,ROOUT,RONEW,AMINP,AMOUT,AMNEW
     &    ,AMTOT(NSYMMAX,NPAT,NSPINMAX)
     &    ,TCH(NSYMMAX,NPAT,2,NSPINMAX)
     &    ,TCHOLD(NSYMMAX,NPAT,2,NSPINMAX)
	DIMENSION Z(NSORTMAX),ZCOR(NSORTMAX)
	LOGICAL SYM(LMMAXV,NPAT),EXIT
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from init
	COMMON /MIXRHO1/ADMIX1,ADMIN,ADMAX,KEY,ADMOPT        !!! from mixro1
        COMMON /MIXMAG1/ADMSPN,ASMIN,ASMAX,KSP,ADSPIN        !!! from mixro1
	COMMON /SYMMLM/ SYM,LMSYM                            !!! from symmlm
	COMMON /MULTRO/ Z,ZCOR,TCH,AMTOT                     !!! from multro
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /SPIN/   NSPIN                                !!! from init
	SAVE TCHOLD
	DATA PI/3.141592653589793D0/
	DO 40 IATOM=1,NATOM
	DO 30 L=0,ILSV(IS(IATOM))
	DO 20 M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	IF(ITER.EQ.0)GOTO10
	ROOUT=(TCH(ISYM,IATOM,1,1)+TCH(ISYM,IATOM,1,NSPIN))/
     &  2.D0*DFLOAT(NSPIN)
	ROINP=(TCHOLD(ISYM,IATOM,1,1)+TCHOLD(ISYM,IATOM,1,NSPIN))/
     &  2.D0*DFLOAT(NSPIN)
	RONEW=ADMOPT*ROOUT+(1.D0-ADMOPT)*ROINP
	AMOUT=(TCH(ISYM,IATOM,1,1)-TCH(ISYM,IATOM,1,NSPIN))
	AMINP=(TCHOLD(ISYM,IATOM,1,1)-TCHOLD(ISYM,IATOM,1,NSPIN))
	AMNEW=ADSPIN*AMOUT+(1.D0-ADSPIN)*AMINP
	TCH(ISYM,IATOM,1,1)=(RONEW+AMNEW)/DFLOAT(NSPIN)
	TCH(ISYM,IATOM,1,NSPIN)=(RONEW-AMNEW)/DFLOAT(NSPIN)
  10	TCHOLD(ISYM,IATOM,1,1)=TCH(ISYM,IATOM,1,1)
	TCHOLD(ISYM,IATOM,1,NSPIN)=TCH(ISYM,IATOM,1,NSPIN)
	ENDIF
  20	CONTINUE
  30	CONTINUE
  40	CONTINUE
	END
