	SUBROUTINE SROINT
**************************************************************
*   Calculate exact density in the interstitial region       *
*   after LMTO wave functions.                               *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &   ,NRAD(NSORTMAX),NKAP(NPANMAX),IATS(NPAT,NPANMAX)
     &   ,ISTS(NSORTMAX,NPANMAX),NSHE(NSORTMAX),NPOL(0:NSORTMAX)
	DIMENSION SMT(NSORTMAX),RINT(0:NSHEMAX,NSORTMAX)
     &   ,GGNT(0:LMAXV+1,0:LMAXV+1,0:LMAXV+1),RLOC(NSORTMAX)
     &   ,SROU(NSORTMAX),GAM(0:LMAXT,NSORTMAX)
     &   ,C(0:LMAXV+1,LMMAXV1,LMMAXV1)
	COMPLEX*16 T(4),ROINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,HAN(3,0:LMAXT),TMP,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
     &   ,ATOSHH(LIMLMB,LIMLMB,NPAT),ATOSHJ(LIMLMB,LIMLMT,NPAT)
     &   ,ATOSJH(LIMLMT,LIMLMB,NPAT),ATOSJJ(LIMLMT,LIMLMT,NPAT)
     &   ,HANR(0:NSHEMAX,0:LMAXT,NKAPMAX),CGNT,BES(3,0:LMAXT)
     &   ,RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROCOR(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROCINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,BESR(0:NSHEMAX,0:LMAXT,NKAPMAX)
     &   ,EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &   ,ALPHA(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
     &   ,ALPDOT(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
     &   ,DLOG(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
	LOGICAL SYM(LMMAXV,NPAT),LOG1,LOG
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
	CHARACTER*10 TXTEL(NSORTMAX)
	COMMON /CONTROL/MAN,LMTO,NLR,NINT                    !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from init
	COMMON /POTCOM/ SWZ,SMT                              !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from init
	COMMON /STORE1/ ATOSHH,ATOSJH,ATOSHJ,ATOSJJ          !!! from ttrint
	COMMON /INTMESH/NSHE,NPOL,SROU,RINT                  !!! from intmsh
	COMMON /DENS/   RO,ROVALDS,ROCOR,ROINT,ROCINT        !!! from rofull
        COMMON /SCRINP/ RLOC,ALPHA,ALPDOT,DLOG               !!! from alpcon
	COMMON /LMTPAR/ GAM                                  !!! from potpar
	COMMON /SYMMLM/ SYM,LMSYM                            !!! from sym
	COMMON /RADMESH/NRAD                                 !!! from radmsh
	COMMON /GAUNT/  C,GGNT                               !!! from gaunt
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /TXTEL/  TXTEL                                !!! from init
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
	IF(NINT.EQ.0)RETURN
	DO 170 ISPIN=1,NSPIN                   !!! over spins
	DO 160 IPAN=1,NPAN                     !!! over panels
	NSHIFT1=0
	NSHIFT2=0
	DO 5 JPAN=1,NPAN
	IF(JPAN.LT.IPAN)NSHIFT1=NSHIFT1+NKAP(JPAN)**2
	NSHIFT2=NSHIFT2+NKAP(JPAN)**2
   5    CONTINUE
	DO 150 IATOM=1,NATOM                   !!! over atoms
	ISORT=IS(IATOM)
	ST=SMT(ISORT)
	DO 30 IKAP=1,NKAP(IPAN)
	DO 20 IRAD=0,NSHE(ISORT)+1
	RT=RINT(IRAD,IS(IATOM))
	CALL BESSEL(RT,EKAP(IKAP,IPAN),ST,BES(1,0),ILST(ISORT))
	CALL HANKEL(RT,EKAP(IKAP,IPAN),ST,HAN(1,0),ILST(ISORT))
	DO 10 L=0,ILST(ISORT)
	HANR(IRAD,L,IKAP)=HAN(1,L)
        BESR(IRAD,L,IKAP)=BES(1,L)-ALPHA(L,ISORT,IKAP,IPAN)/
     &  GAM(L,ISORT)*HAN(1,L)
  10    CONTINUE
  20    CONTINUE
  30    CONTINUE
	DO 60 L2=0,ILSV(ISORT)               !!! over l2
	DO 50 M2=-L2,L2                      !!! over m2
	LM2=L2*(L2+1)+M2+1
	IF(SYM(LM2,IATOM))THEN
	ISYM=LMSYM(LM2,IATOM)
	DO 40 IRAD=0,NSHE(ISORT)+1            !!! over radial mesh
	IF(IPAN.EQ.1)ROINT(IRAD,ISYM,IATOM,ISPIN)=(0.D0,0.D0)
  40    CONTINUE                             !!! over radial mesh
	ENDIF
  50    CONTINUE                               !!! over m2
  60    CONTINUE                               !!! over l2
	DO 140 IKAP1=1,NKAP(IPAN)              !!! over energies
	DO 130 IKAP=1,NKAP(IPAN)               !!! over energies
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NSHIFT1*NATOM+NSHIFT2*NATOM*(ISPIN-1)
	READ(21,REC=IREC)((ATOSHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((ATOSJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
	DO 120 L1=0,ILST(ISORT)                !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO 110 M1=-L1,L1                       !!! over m1
	LM1=L1*(L1+1)+M1+1
	DO 100 L=0,ILST(ISORT)                 !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO 90 M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	DO 80 L2=ABS(L1-L),L1+L,2              !!! over l2 (expansion of ro)
	M2=M-M1
	LM2=L2*(L2+1)+M2+1
	IF(ABS(M2).LE.L2.AND.L2.LE.ILSV(ISORT))THEN ! over m2 (expansion of ro)
	IF(SYM(LM2,IATOM))THEN
	ISYM=LMSYM(LM2,IATOM)
	CGNT=(0.D0,1.D0)**(L-L1-L2)*C(L2/2,LM,LM1)
	DO 70 IRAD=0,NSHE(ISORT)+1             !!! over radial mesh
	IF(LOG1.AND.LOG)
     &  ROINT(IRAD,ISYM,IATOM,ISPIN)=ROINT(IRAD,ISYM,IATOM,ISPIN)+
     &  (ATOSHH(LM1,LM,IATOM)*
     &  CONJG(HANR(IRAD,L1,IKAP1))*HANR(IRAD,L,IKAP))*CGNT
	IF(LOG1)
     &  ROINT(IRAD,ISYM,IATOM,ISPIN)=ROINT(IRAD,ISYM,IATOM,ISPIN)-
     &  (ATOSHJ(LM1,LM,IATOM)*GAM(L,ISORT)*
     &  CONJG(HANR(IRAD,L1,IKAP1))*BESR(IRAD,L,IKAP))*CGNT
	IF(LOG)
     &  ROINT(IRAD,ISYM,IATOM,ISPIN)=ROINT(IRAD,ISYM,IATOM,ISPIN)-
     &  (ATOSJH(LM1,LM,IATOM)*GAM(L1,ISORT)*
     &  CONJG(BESR(IRAD,L1,IKAP1))*HANR(IRAD,L,IKAP))*CGNT
	ROINT(IRAD,ISYM,IATOM,ISPIN)=ROINT(IRAD,ISYM,IATOM,ISPIN)+
     &  (ATOSJJ(LM1,LM,IATOM)*GAM(L1,ISORT)*GAM(L,ISORT)*
     &  CONJG(BESR(IRAD,L1,IKAP1))*BESR(IRAD,L,IKAP))*CGNT
  70    CONTINUE                               !!! over radial mesh
	ENDIF
	ENDIF                                  !!! over m2
  80    CONTINUE                               !!! over l2
  90    CONTINUE                               !!! over m
 100    CONTINUE                               !!! over l
 110    CONTINUE                               !!! over m1
 120    CONTINUE                               !!! over l1
 130    CONTINUE                               !!! over energies
 140    CONTINUE                               !!! over energies
C  CHECK DENSITY MATCHING
	IF(IPAN.EQ.NPAN)THEN
	DO 145 LM=1,(ILST(ISORT)+1)**2
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	TM=ABS(RO(NRAD(ISORT),ISYM,IATOM,ISPIN)-
     &  ROINT(0,ISYM,IATOM,ISPIN))
	IF(TM.GT.1.D-08)WRITE(IUN,1010)TM,LM,IATOM,ISPIN
	ENDIF
 145    CONTINUE
	ENDIF
 150    CONTINUE                               !!! over atoms
 160    CONTINUE                               !!! over panels
 170    CONTINUE                               !!! over spins
1010    FORMAT(1X,'<ROINT> :: Densities are not match ',
     &  G14.7,1X,I2,1X,I2,1X,I2)
	END
