	SUBROUTINE SCRSTR(IPNT,IPAN)
*******************************************************
*   The calculation of the structure constants.       *
*   Last revision: 30.11.92, S.S.                     *
*******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NKAP(NPANMAX),NPNT(NPANMAX)
     &    ,ISENV(0:NENVMAX,NPAT),NENV(NPAT),NDIV(3),NDIC(3)
	COMPLEX*16 SS(LIMLMT1,NPAT,LIMLMB,NPAT,NKAPMAX)
     &    ,SSDOT(LIMLMB1,NPAT,LIMLMB,NPAT,NKAPMAX)
     &    ,SCRSS(LIMLMT,0:NENVMAX,LIMLMB),EXPKR
     &    ,SCRSD(LIMLMB,0:NENVMAX,LIMLMB) 
     &    ,SBARE(LIMLMT,LIMLMB,0:NENVMAX)
     &    ,SBDOT(LIMLMB,LIMLMB,0:NENVMAX)
     &    ,EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
	DIMENSION SMT(NSORTMAX),PNT(3,KMAX,NPANMAX),SH(3,NPANMAX)
     &    ,TENV(3,0:NENVMAX,NPAT),TAU(3,NPAT)
	LOGICAL FIRST,LOG
	COMMON /CONTROL/LIFT,LMTO,NLR,NINT                      !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM           !!! from init
	COMMON /POTCOM/ SWZ,SMT                                 !!! from init
	COMMON /BASIS/  TAU                                     !!! from init
	COMMON /DENS/   SS,SSDOT                                !!! from strgnt
	COMMON /STORE1/ SBARE,SBDOT                             !!! from barcon
	COMMON /STORE2/ SCRSS,SCRSD                             !!! from scrcon
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                       !!! from init
	COMMON /ENVSITE/NENV,TENV,ISENV                         !!! from envmesh
	COMMON /MESH/   NPNT,PNT                                !!! from ttrmsh
	COMMON /INTTR/  NDIV,NDIC,SH                            !!! from init
	COMMON /LATPAR/ PAR                                     !!! from init
	COMMON /SPIN/   NSPIN                                   !!! from init
	COMMON /UNIT/   IUN                                     !!! from init
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
	IF(LMTO.NE.3)RETURN
C ***** DO GLOBALLY OVER ATOMS AND ENERGIES *****
	IRECORD=1
	DO 2000 IKAP=1,NKAP(IPAN)                !!! over diff.energies
	DO 1000 IATOM=1,NATOM                    !!! over jatom
	ISORT=IS(IATOM)
C READ SCREENED STRUCTURE CONSTANTS FOR VALENCE PANEL
	IF(IPAN.EQ.1)THEN 
	DO 100 IENV=0,NENV(IATOM)
	IRECORD=IRECORD+1
	IREC=IRECORD
	READ(18,REC=IREC)LIM2T,LIM2B,
     &  ((SCRSS(L1M1,IENV,LM),L1M1=1,LIM2T),LM=1,LIM2B),
     &  ((SCRSD(L1M1,IENV,LM),L1M1=1,LIM2B),LM=1,LIM2B)
 100    CONTINUE
	ELSEIF(IPAN.NE.1)THEN 
C CALCULATE SCREENED STRUCTURE CONSTANTS FOR SEMICORE ENERGIES
	DO 210 IENV=0,NENV(IATOM)
	JATOM=ISENV(IENV,IATOM)
	TX=-TENV(1,IENV,IATOM)
	TY=-TENV(2,IENV,IATOM)
	TZ=-TENV(3,IENV,IATOM)
	CALL BARCON(IKAP,IPAN,JATOM,IATOM,TX,TY,TZ,
     &  SBARE(1,1,IENV),SBDOT(1,1,IENV))
 210    CONTINUE
	DO 260 L=0,ILSB(ISORT)                    !!! over l
	DO 250 M=-L,L                             !!! over m
	LM=L*(L+1)+M+1
	IND1=0
	DO 240 IENV=0,NENV(IATOM)                 !!! over ienv1
	JATOM=ISENV(IENV,IATOM)
	JSORT=IS(JATOM)
	DO 230 L1=0,ILST(JSORT)                   !!! over l1
	DO 220 M1=-L1,L1                          !!! over m1
	L1M1=L1*(L1+1)+M1+1
	SCRSS(L1M1,IENV,LM)=SBARE(L1M1,LM,IENV)
	IF(L1.LE.ILSB(JSORT))
     &  SCRSD(L1M1,IENV,LM)=SBDOT(L1M1,LM,IENV)
 220    CONTINUE                                  !!! over m1
 230    CONTINUE                                  !!! over l1
 240    CONTINUE                                  !!! over ienv1
 250    CONTINUE                                  !!! over m
 260    CONTINUE                                  !!! over l
	ENDIF
C  RESTORE FULL S AND S_DOT -MATRICES FOR DIFF.ENERGIES
	DO 370 L=0,ILSB(IS(IATOM))                !!! over l
	DO 360 M=-L,L                             !!! over m
	LM=L*(L+1)+M+1
	DO 350 JATOM=1,NATOM                      !!! over atoms
	JSORT=IS(JATOM)
	DO 340 L1=0,ILST(JSORT)                   !!! over l1
	LOG=.FALSE.
	IF(L1.LE.ILSB(JSORT))LOG=.TRUE.
	DO 330 M1=-L1,L1                          !!! over m1
	L1M1=L1*(L1+1)+M1+1
	SS(L1M1,JATOM,LM,IATOM,IKAP)=(0.0,0.0)
	IF(LOG)SSDOT(L1M1,JATOM,LM,IATOM,IKAP)=(0.0,0.0)
 330    CONTINUE                                  !!! over m1
 340    CONTINUE                                  !!! over l1
 350    CONTINUE                                  !!! over jatom
 360    CONTINUE                                  !!! over m
 370    CONTINUE                                  !!! over l
	DO 470 L=0,ILSB(IS(IATOM))                !!! over l
	DO 460 M=-L,L                             !!! over m
	LM=L*(L+1)+M+1
	DO 450 IENV=0,NENV(IATOM)                 !!! over atoms
	JATOM=ISENV(IENV,IATOM)
	JSORT=IS(JATOM)
	RX=TENV(1,IENV,IATOM)+(TAU(1,IATOM)-TAU(1,JATOM))
	RY=TENV(2,IENV,IATOM)+(TAU(2,IATOM)-TAU(2,JATOM))
	RZ=TENV(3,IENV,IATOM)+(TAU(3,IATOM)-TAU(3,JATOM))
	XK=PNT(1,IPNT,IPAN)+SH(1,IPAN)
	YK=PNT(2,IPNT,IPAN)+SH(2,IPAN)
	ZK=PNT(3,IPNT,IPAN)+SH(3,IPAN)
	SCP=XK*RX+YK*RY+ZK*RZ
	EXPKR=EXP((0.D0,-1.D0)*SCP*2.D0*PI) 
	DO 440 L1=0,ILST(JSORT)                   !!! over l1
	LOG=.FALSE.
	IF(L1.LE.ILSB(JSORT))LOG=.TRUE.
	DO 430 M1=-L1,L1                          !!! over m1
	L1M1=L1*(L1+1)+M1+1
	SS(L1M1,JATOM,LM,IATOM,IKAP)=SS(L1M1,JATOM,LM,IATOM,IKAP)+
     &  EXPKR*SCRSS(L1M1,IENV,LM)
	IF(LOG)
     &  SSDOT(L1M1,JATOM,LM,IATOM,IKAP)=SSDOT(L1M1,JATOM,LM,IATOM,IKAP)+
     &  EXPKR*SCRSD(L1M1,IENV,LM)
 430    CONTINUE                                   !!! over m1
 440    CONTINUE                                   !!! over l1
 450    CONTINUE                                   !!! over jatom
 460    CONTINUE                                   !!! over m
 470    CONTINUE                                   !!! over l
1000    CONTINUE                                   !!! over iatom
2000    CONTINUE                                   !!! over diff.energies
	END
