	SUBROUTINE SPLNRO
**************************************************************
*  Spline old density into new radial mesh.                  *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	CHARACTER TXTEL(NSORTMAX)*10
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NHSORT(NSORTMAX),NSYMOLD(NPAT),LMOLD(NSYMMAX,NPAT)
     &   ,NRADOLD(NSORTMAX),NRAD(NSORTMAX),NPOL(0:NSORTMAX)
     &   ,NSHE(NSORTMAX),NSHEOLD(NSORTMAX)
	DIMENSION DERIN(0:NRADMAX+NSHEMAX,2),H(NSORTMAX)
     &   ,ROLD(0:NRADMAX,NSORTMAX),RINTOLD(0:NSHEMAX,NSORTMAX)
     &   ,SROU(NSORTMAX),RINT(0:NSHEMAX,NSORTMAX)
     &   ,WORK1(0:NRADMAX,2),WORK2(0:NRADMAX,2),WORK3(0:NSHEMAX,2)
     &   ,WORK4(0:NSHEMAX,2),WEIGHT(0:NRADMAX,NSORTMAX)
     &   ,R(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,DEROUT(0:NRADMAX,2),RTMP(0:NRADMAX+NSHEMAX)
     &   ,ROTMPR(0:NRADMAX+NSHEMAX),ROTMPI(0:NRADMAX+NSHEMAX)
     &   ,ROCTMPR(0:NRADMAX+NSHEMAX),ROCTMPI(0:NRADMAX+NSHEMAX)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROCOR(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROCINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!! from init
	COMMON /DENS/    RO,ROVALDS,ROCOR,ROINT,ROCINT      !!! from vfull
	COMMON /RADMESH/ NRAD,H,R,DR,WEIGHT                 !!! from radmsh
	COMMON /INTMESH/ NSHE,NPOL,SROU,RINT                !!! from intmsh
	COMMON /OLDMESH/ NSYMOLD,LMOLD,NRADOLD,NSHEOLD,ROLD,RINTOLD
	COMMON /SPIN/    NSPIN                              !!! from init
	COMMON /TXTEL/   TXTEL                              !!! from init
	COMMON /UNIT/    IUN                                !!! from init
	DATA PI/3.141592653589793D0/
	DO 185 ISPIN=1,NSPIN                     !!! over spins
	DO 180 IATOM=1,NATOM                     !!! over atoms
	ISORT=IS(IATOM)
	DO 10 I=0,NRAD(ISORT)
	IF(R(I,ISORT)-ROLD(NRADOLD(ISORT),ISORT).GT.1.D-09)GOTO20
  10    CONTINUE
	I=NRAD(ISORT)+1
  20    NR=I-1
	NM=0
	DO 30 I=0,NSHE(ISORT)+1
	IF(RINT(I,ISORT)-RINTOLD(0,ISORT).LE.-1.D-09)NM=I+1
	IF(RINT(I,ISORT)-RINTOLD(NSHEOLD(ISORT)+1,ISORT).GT.1.D-09)
     &  GOTO40
  30    CONTINUE
	I=NSHE(ISORT)+2
  40    NS=I-1
	DO 120 ISYM=1,NSYMOLD(IATOM)
	DO 50 I=0,NRADOLD(ISORT)
	RTMP(I)=ROLD(I,ISORT)
	ROTMPR(I)=DREAL(RO(I,ISYM,IATOM,ISPIN))
	ROTMPI(I)=DIMAG(RO(I,ISYM,IATOM,ISPIN))
	ROCTMPR(I)=DREAL(ROCOR(I,ISYM,IATOM,ISPIN))
	ROCTMPI(I)=DIMAG(ROCOR(I,ISYM,IATOM,ISPIN))
  50    CONTINUE
	DO 60 I=1,NSHEOLD(ISORT)+1
	IRAD=NRADOLD(ISORT)+I
	RTMP(IRAD)=RINTOLD(I,ISORT)
	ROTMPR(IRAD)=DREAL(ROINT(I,ISYM,IATOM,ISPIN))
	ROTMPI(IRAD)=DIMAG(ROINT(I,ISYM,IATOM,ISPIN))
	ROCTMPR(IRAD)=DREAL(ROCINT(I,ISYM,IATOM,ISPIN))
	ROCTMPI(IRAD)=DIMAG(ROCINT(I,ISYM,IATOM,ISPIN))
  60    CONTINUE
	CALL SPLIN3(RTMP,ROTMPR,DERIN,NRADOLD(ISORT)+2+
     &  NSHEOLD(ISORT),NRADMAX+NSHEMAX+1,R(0,ISORT),WORK1(0,1),
     &  DEROUT,NRAD(ISORT)+1,NRADMAX+1,-1)
	CALL SPLIN3(RTMP,ROTMPI,DERIN,NRADOLD(ISORT)+2+
     &  NSHEOLD(ISORT),NRADMAX+NSHEMAX+1,R(0,ISORT),WORK1(0,2),
     &  DEROUT,NRAD(ISORT)+1,NRADMAX+1,-1)
	CALL SPLIN3(RTMP,ROCTMPR,DERIN,NRADOLD(ISORT)+2+
     &  NSHEOLD(ISORT),NRADMAX+NSHEMAX+1,R(0,ISORT),WORK2(0,1),
     &  DEROUT,NRAD(ISORT)+1,NRADMAX+1,-1)
	CALL SPLIN3(RTMP,ROCTMPI,DERIN,NRADOLD(ISORT)+2+
     &  NSHEOLD(ISORT),NRADMAX+NSHEMAX+1,R(0,ISORT),WORK2(0,2),
     &  DEROUT,NRAD(ISORT)+1,NRADMAX+1,-1)
	DO 70 I=0,NRAD(ISORT)
	RO(I,ISYM,IATOM,ISPIN)=DCMPLX(WORK1(I,1),WORK1(I,2))
	ROCOR(I,ISYM,IATOM,ISPIN)=DCMPLX(WORK2(I,1),WORK2(I,2))
  70    CONTINUE
	ROVALDS(1,ISYM,IATOM,ISPIN)=RO(NRAD(ISORT),ISYM,IATOM,ISPIN)
	CALL SPLIN3(RTMP,ROTMPR,DERIN,NRADOLD(ISORT)+2+
     &  NSHEOLD(ISORT),NRADMAX+NSHEMAX+1,RINT(1,ISORT),WORK3(1,1),
     &  DEROUT,NS,NRADMAX+1,-1)
	CALL SPLIN3(RTMP,ROTMPI,DERIN,NRADOLD(ISORT)+2+
     &  NSHEOLD(ISORT),NRADMAX+NSHEMAX+1,RINT(1,ISORT),WORK3(1,2),
     &  DEROUT,NS,NRADMAX+1,-1)
	CALL SPLIN3(RTMP,ROCTMPR,DERIN,NRADOLD(ISORT)+2+
     &  NSHEOLD(ISORT),NRADMAX+NSHEMAX+1,RINT(1,ISORT),WORK4(1,1),
     &  DEROUT,NS,NRADMAX+1,-1)
	CALL SPLIN3(RTMP,ROCTMPI,DERIN,NRADOLD(ISORT)+2+
     &  NSHEOLD(ISORT),NRADMAX+NSHEMAX+1,RINT(1,ISORT),WORK4(1,2),
     &  DEROUT,NS,NRADMAX+1,-1)
	DO 90 I=1,NS
	ROINT(I,ISYM,IATOM,ISPIN)=DCMPLX(WORK3(I,1),WORK3(I,2))
	ROCINT(I,ISYM,IATOM,ISPIN)=DCMPLX(WORK4(I,1),WORK4(I,2))
  90    CONTINUE
	ROINT(0,ISYM,IATOM,ISPIN)=RO(NRAD(ISORT),ISYM,IATOM,ISPIN)
	ROCINT(0,ISYM,IATOM,ISPIN)=ROCOR(NRAD(ISORT),ISYM,IATOM,ISPIN)
	DO 110 I=NS+1,NSHE(ISORT)+1
	ROINT(I,ISYM,IATOM,ISPIN)=ROINT(NS,ISYM,IATOM,ISPIN)
	ROCINT(I,ISYM,IATOM,ISPIN)=ROCINT(NS,ISYM,IATOM,ISPIN)
 110    CONTINUE
 120    CONTINUE
 180    CONTINUE                                !!! over atoms
 185    CONTINUE                                !!! over spins
	END
