	SUBROUTINE STRALP(IPNT,IPAN)
***********************************************************
*   The calculation of the screened structure constants.  * 
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NKAP(NPANMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &    ,ALPHA(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
     &    ,ALPDOT(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
     &    ,DLOG(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
     &    ,SS(LIMLMT1,NPAT,LIMLMB,NPAT,NKAPMAX)
     &    ,SD(LIMLMB1,NPAT,LIMLMB,NPAT,NKAPMAX)
     &    ,XM(LIMLMB*NPAT,LIMLMB*NPAT),SW(LIMLMT1,NPAT)
     &    ,WD(LIMLMB,NPAT,LIMLMB,NPAT)
	DIMENSION SMT(NSORTMAX),RLOC(NSORTMAX),WRK(LIMLMB*NPAT)
        LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &    ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NLR,NINT                      !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM           !!! from readini
	COMMON /SPIN/   NSPIN                                   !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT                                 !!! from readini
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                       !!! from readini
	COMMON /LATPAR/ PAR                                     !!! from readini
        COMMON /PANPAR/ LTPAN,LSPAN                             !!! from readini
        COMMON /SCRINP/ RLOC,ALPHA,ALPDOT,DLOG                  !!! from alpcon
C Temporary storage
	COMMON /STORE1/ WD,XM                                   !!! tmp.storage
C Structure constants:
	COMMON /DENS/   SS,SD                                   !!! from strgnt
C Outputs:
	COMMON /UNIT/   IUN                                     !!! from readini
	DATA PI/3.141592653589793D0/
	IF(LMTO.NE.2)RETURN
        DO 1000 IKAP=1,NKAP(IPAN)           !!! over ikap1
C  CHECK SCREENING
	CHK=0.D0
	DO ISORT=1,NSORT
	DO L=0,ILSB(ISORT)
	CHK=CHK+ABS(ALPHA(L,ISORT,IKAP,IPAN)) 
	ENDDO
	ENDDO
	IF(ABS(CHK).LE.1.D-07)GOTO1000      !!! no screening
C  SET RECIPROCAL TRANSFORMATION MATRIX
        IDIM1=0
        DO IATOM1=1,NATOM                   !!! over iatom1
        ISORT1=IS(IATOM1)
        DO L1=0,ILSB(ISORT1)                !!! over l1
        DO M1=-L1,L1                        !!! over m1
        L1M1=L1*(L1+1)+M1+1
        IDIM1=IDIM1+1
        IDIM=0
        DO IATOM=1,NATOM                    !!! over iatom
        ISORT=IS(IATOM)
        DO L=0,ILSB(ISORT)                  !!! over l
        DO M=-L,L                           !!! over m
        LM=L*(L+1)+M+1
        IDIM=IDIM+1
        XM(IDIM1,IDIM)=-ALPHA(L1,ISORT1,IKAP,IPAN)*
     &  SS(L1M1,IATOM1,LM,IATOM,IKAP)*ALPHA(L,ISORT,IKAP,IPAN)
        ENDDO                               !!! over m
        ENDDO                               !!! over l
        ENDDO                               !!! over iatom
        XM(IDIM1,IDIM1)=XM(IDIM1,IDIM1)+ALPHA(L1,ISORT1,IKAP,IPAN)
        ENDDO                               !!! over m1
        ENDDO                               !!! over l1
        ENDDO                               !!! over iatom1
	MDIM=IDIM1
C  INVERT MATRIX
        CALL CINV(MDIM,XM,LIMLMB*NPAT,WRK,IFAIL)
        IF(IFAIL.NE.0)PRINT*,'<STRALP>:: ERROR IN INVERSION PROGRAM'
C  SCREENED STRUCTURE CONSTANTS
C  Sa=[1-S0*A]^{-1}*S0=(A-A*S0*A)^{-1}-1/A
	IDIM1=0
        DO IATOM1=1,NATOM                   !!! over iatom1
        ISORT1=IS(IATOM1)
        DO L1=0,ILSB(ISORT1)                !!! over l1
        DO M1=-L1,L1                        !!! over m1
        L1M1=L1*(L1+1)+M1+1
	IDIM1=IDIM1+1
	IDIM=0
        DO IATOM=1,NATOM                    !!! over iatom
        ISORT=IS(IATOM)
        DO L=0,ILSB(ISORT)                  !!! over l
        DO M=-L,L                           !!! over m
        LM=L*(L+1)+M+1
        IDIM=IDIM+1
	SS(L1M1,IATOM1,LM,IATOM,IKAP)=XM(IDIM1,IDIM)
        ENDDO                               !!! over m
        ENDDO                               !!! over l
        ENDDO                               !!! over iatom
	SS(L1M1,IATOM1,L1M1,IATOM1,IKAP)=
     &  SS(L1M1,IATOM1,L1M1,IATOM1,IKAP)-
     &  1.D0/ALPHA(L1,ISORT1,IKAP,IPAN)
        ENDDO                               !!! over m1
        ENDDO                               !!! over l1
        ENDDO                               !!! over iatom1
C EXPAND SCREENED STRUCTURE CONSTANTS FOR HIGHER L'S
C S(a)=S(0)*(1+A*S(a))=[1-S(0)A]^{-1}*S(0)
	IDIM1=0
        DO IATOM1=1,NATOM                   !!! over ienv1
        ISORT1=IS(IATOM1)
        DO L1=ILSB(ISORT1)+1,ILST(ISORT1)   !!! over l1
        DO M1=-L1,L1                        !!! over m1
        L1M1=L1*(L1+1)+M1+1
	IDIM1=IDIM1+1
	IDIM=0
        DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
        DO L=0,ILSB(ISORT)                  !!! over l
        DO M=-L,L                           !!! over m
        LM=L*(L+1)+M+1
	IDIM=IDIM+1
	SW(LM,IATOM)=SS(L1M1,IATOM1,LM,IATOM,IKAP)
        DO IATOM2=1,NATOM                   !!! over iatom2
        ISORT2=IS(IATOM2)
        DO L2=0,ILSB(ISORT2)                !!! over l2
        DO M2=-L2,L2                        !!! over m2
        L2M2=L2*(L2+1)+M2+1
	SW(LM,IATOM)=SW(LM,IATOM)+
     &  SS(L1M1,IATOM1,L2M2,IATOM2,IKAP)*
     &  ALPHA(L2,ISORT2,IKAP,IPAN)*
     &  SS(L2M2,IATOM2,LM,IATOM,IKAP)
        ENDDO                               !!! over m2
        ENDDO                               !!! over l2
        ENDDO                               !!! over iatom2
        ENDDO                               !!! over m
        ENDDO                               !!! over l
        ENDDO                               !!! over iatom
        DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
        DO L=0,ILSB(ISORT)                  !!! over l
        DO M=-L,L                           !!! over m
        LM=L*(L+1)+M+1
	SS(L1M1,IATOM1,LM,IATOM,IKAP)=SW(LM,IATOM)
        ENDDO                               !!! over m
        ENDDO                               !!! over l
        ENDDO                               !!! over iatom
        ENDDO                               !!! over m1
        ENDDO                               !!! over l1
        ENDDO                               !!! over iatom1
C GENERATE ENERGY DERIVATIVES OF THE SCREENED STR.CON.
        IDIM2=0
        DO IATOM2=1,NATOM                   !!! over iatom2
        ISORT2=IS(IATOM2)
        DO L2=0,ILSB(ISORT2)                !!! over l2
        DO M2=-L2,L2                        !!! over m2
        L2M2=L2*(L2+1)+M2+1
        IDIM2=IDIM2+1
	IDIM=0
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)          
        DO L=0,ILSB(ISORT)                  !!! over l
        DO M=-L,L                           !!! over m
        LM=L*(L+1)+M+1
	IDIM=IDIM+1
        WD(L2M2,IATOM2,LM,IATOM)=(0.D0,0.D0)
        IDIM3=0
        DO IATOM3=1,NATOM                   !!! over ienv3
        ISORT3=IS(IATOM3)
        DO L3=0,ILSB(ISORT3)                !!! over l3
        DO M3=-L3,L3                        !!! over m3
        L3M3=L3*(L3+1)+M3+1
        IDIM3=IDIM3+1
        WD(L2M2,IATOM2,LM,IATOM)=WD(L2M2,IATOM2,LM,IATOM)+
     &  ALPHA(L2,ISORT2,IKAP,IPAN)*SD(L2M2,IATOM2,L3M3,IATOM3,IKAP)*
     &  ALPHA(L3,ISORT3,IKAP,IPAN)*XM(IDIM3,IDIM)
        ENDDO                               !!! over m3
        ENDDO                               !!! over l3
        ENDDO                               !!! over iatom3
        ENDDO                               !!! over m
        ENDDO                               !!! over l
        ENDDO                               !!! over iatom
        ENDDO                               !!! over m2
        ENDDO                               !!! over l2
        ENDDO                               !!! over iatom2
C
	IDIM=0
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)          
        DO L=0,ILSB(ISORT)                  !!! over l
        DO M=-L,L                           !!! over m
        LM=L*(L+1)+M+1
	IDIM=IDIM+1
        IDIM1=0
        DO IATOM1=1,NATOM                   !!! over iatom1
        ISORT1=IS(IATOM1)
        DO L1=0,ILSB(ISORT1)                !!! over l1
        DO M1=-L1,L1                        !!! over m1
        L1M1=L1*(L1+1)+M1+1
        SD(L1M1,IATOM1,LM,IATOM,IKAP)=(0.D0,0.D0)
        IDIM1=IDIM1+1
        IDIM2=0
        DO IATOM2=1,NATOM                   !!! over iatom2
        ISORT2=IS(IATOM2)
        DO L2=0,ILSB(ISORT2)                !!! over l2
        DO M2=-L2,L2                        !!! over m2
        L2M2=L2*(L2+1)+M2+1
        IDIM2=IDIM2+1
        SD(L1M1,IATOM1,LM,IATOM,IKAP)=SD(L1M1,IATOM1,LM,IATOM,IKAP)+
     &  XM(IDIM1,IDIM2)*WD(L2M2,IATOM2,LM,IATOM)
        SD(L1M1,IATOM1,LM,IATOM,IKAP)=SD(L1M1,IATOM1,LM,IATOM,IKAP)+
     &  XM(IDIM1,IDIM2)*ALPDOT(L2,ISORT2,IKAP,IPAN)*
     &  SS(L2M2,IATOM2,LM,IATOM,IKAP)
        ENDDO                               !!! over m2
        ENDDO                               !!! over l2
        ENDDO                               !!! over iatom2
        SD(L1M1,IATOM1,LM,IATOM,IKAP)=SD(L1M1,IATOM1,LM,IATOM,IKAP)-
     &  1.D0/ALPHA(L1,ISORT1,IKAP,IPAN)*ALPDOT(L1,ISORT1,IKAP,IPAN)*
     &  SS(L1M1,IATOM1,LM,IATOM,IKAP)
        ENDDO                               !!! over m1
        ENDDO                               !!! over l1
        ENDDO                               !!! over iatom1
        ENDDO                               !!! over m
        ENDDO                               !!! over l
        ENDDO                               !!! over iatom
1000	CONTINUE                            !!! over ikap
	END
