	SUBROUTINE SUMSUB(ASUM,IBNDT,IBNDS,IORBS,IPNT,IPAN,IREAD)
**********************************************************
* Program calculates tl-characters of wave functions.    *
* Written by S.Savrasov in Max-Planck-Institute, Germany *
**********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),NBNDF(NPANMAX),NPNT(NPANMAX)
     &   ,NBNDE(NPANMAX),NBNDT(NPANMAX),NKAP(NPANMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
	COMPLEX*16 APH(LIMLMB,NPAT,NKAPMAX),APJ(LIMLMT1,NPAT,NKAPMAX)
     &   ,OHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,OJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,OHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,OJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX),AHH,AHJ,AJH,AJJ
     &   ,ASUM(0:LMAXT,NSORTMAX,NKAPMAX,NKAPMAX)
	DIMENSION SMT(NSORTMAX),GAM(0:LMAXT,NSORTMAX)
     &   ,PNT(3,KMAX,NPANMAX)
	LOGICAL LOG,LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT  !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                 !!! from init
	COMMON /POTCOM/ SWZ,SMT                               !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                     !!! from init
	COMMON /SUMPAR/ OHH,OJH,OHJ,OJJ                       !!! from ovrpar
	COMMON /LATPAR/ PAR                                   !!! from init
	COMMON /LMTPAR/ GAM                                   !!! from potpar
	COMMON /OUT1/   ICON,IFTR,IKOV,IWF,ITMP,IBAN,IPOT     !!! from init 
     &                 ,IPTN,IDOS,ISCF,IOUT
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                     !!! from init
	COMMON /MESH/   NPNT,PNT                              !!! from init
	COMMON /ORBS/   NORBS                                 !!! from init
	COMMON /SPIN/   NSPIN                                 !!! from init
	ANORM=0.D0
	DO IKAP=1,NKAP(IPAN)
	IF(IREAD.EQ.0)THEN
        IREC=IKAP+NKAP(IPAN)*(IBNDT-1)+
     &  NKAP(IPAN)*NBNDF(IPAN)*(IBNDS-1)+
     &  NKAP(IPAN)*NBNDF(IPAN)*NSPIN*(IORBS-1)
        READ(14,REC=IREC)
     &  ((APH(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM),
     &  ((APJ(LM,IATOM,IKAP),LM=1,(ILST(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM)
	ELSEIF(IREAD.EQ.1)THEN  !!! valid only for panel #1
        IREC=IKAP+NKAP(1)*(IBNDT-NBNDE(1))+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*(IORBS-1)+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNT-1)
        READ(15,REC=IREC)
     &  ((APH(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM),
     &  ((APJ(LM,IATOM,IKAP),LM=1,(ILST(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM)
	ENDIF
	ENDDO
C  AVARAGING OVER ALL ATOMS OF THIS SORT AND OVER ALL M FOR THIS L
        IF(NORBS.EQ.1)ISPIN=IBNDS
        IF(NORBS.EQ.2)ISPIN=IORBS
	ANORM=0.D0
	DO IKAP1=1,NKAP(IPAN)                                 !!! over energies
	DO IKAP=1,NKAP(IPAN)                                  !!! over energies
	DO ISORT=1,NSORT                                      !!! over isort
	DO L=0,ILST(ISORT)                                    !!! over l
	AHH=(0.D0,0.D0)
	AHJ=(0.D0,0.D0)
	AJH=(0.D0,0.D0)
	AJJ=(0.D0,0.D0)
	DO IATOM=1,NATOM                                      !!! over atoms
	IF(ISORT.EQ.IS(IATOM))THEN
	DO M=-L,L                                             !!! over m
	LM=L*(L+1)+M+1
	IF(LSPAN(L,ISORT,IKAP1,IPAN).AND.LSPAN(L,ISORT,IKAP,IPAN))
     &	AHH=AHH+CONJG(APH(LM,IATOM,IKAP1))*APH(LM,IATOM,IKAP)*
     &  OHH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)
	IF(LSPAN(L,ISORT,IKAP,IPAN))
     &	AJH=AJH-CONJG(APJ(LM,IATOM,IKAP1))*APH(LM,IATOM,IKAP)*
     &  OJH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)
	IF(LSPAN(L,ISORT,IKAP1,IPAN))
     &	AHJ=AHJ-CONJG(APH(LM,IATOM,IKAP1))*APJ(LM,IATOM,IKAP)*
     &  OHJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)
	AJJ=AJJ+CONJG(APJ(LM,IATOM,IKAP1))*APJ(LM,IATOM,IKAP)*
     &  OJJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)
        ENDDO                                                 !!! over m
	ENDIF
        ENDDO                                                 !!! over atoms
	ASUM(L,ISORT,IKAP1,IKAP)=(AHH+AHJ+AJH+AJJ)/DBLE(NHSORT(ISORT))
	ANORM=ANORM+ASUM(L,ISORT,IKAP1,IKAP)*NHSORT(ISORT)
        ENDDO                                                 !!! over l
        ENDDO                                                 !!! over isort
        ENDDO                                                 !!! over ikap
        ENDDO                                                 !!! over ikap1
C  NORMALIZATION
	IF(ABS(ANORM).LE.1.D-10)ANORM=1.D0
	DO IKAP1=1,NKAP(IPAN)                                 !!! over energies
	DO IKAP=1,NKAP(IPAN)                                  !!! over energies
	DO ISORT=1,NSORT                                      !!! over isort
	DO L=0,ILST(ISORT)                                    !!! over l
C	ASUM(L,ISORT,IKAP1,IKAP)=ASUM(L,ISORT,IKAP1,IKAP)/ANORM
        ENDDO                                                 !!! over l
        ENDDO                                                 !!! over isort
        ENDDO                                                 !!! over ikap
        ENDDO                                                 !!! over ikap1
C  SAVE TL-CHARACTERS IN SCRATCH FILE
	IF(IDOS.NE.0.AND.IPAN.EQ.1)THEN
	IREC=IBNDT+NBNDF(1)*(IBNDS-1)+NBNDF(1)*NSPIN*(IORBS-1)+
     &  NBNDF(1)*NSPIN*NORBS*(IPNT-1)
	WRITE(17,REC=IREC)((((ASUM(L,ISORT,IKAP1,IKAP),L=0,ILST(ISORT)),
     &  ISORT=1,NSORT),IKAP=1,NKAP(1)),IKAP1=1,NKAP(1))
	ENDIF
	END
