	SUBROUTINE SRFGRD(IATOM,NMSH,WCEL,PCEL)
**************************************************************
*  The calculation of the weights for the integratoion       *
*  over the interstitial region. The calculation of their    *
*  gradients with respect to the displacement of the origin. *
*  After Dima.Yu.Savrasov (P.N.Lebedev PhysicaL Institute)   *
*  Last revision: 03.02.93.                                  *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (NTRMAX=NENVMAX)
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,LISTTR(3,NTRMAX,NENVMAX),NMSG(NENVMAX),IS(NPAT)
     &   ,NTR(NENVMAX),ISENV(0:NENVMAX),IREFAT(0:NVCMAX)
     &   ,NSHE(NSORTMAX),NPOL(0:NSORTMAX)
	DIMENSION POLIST(3,NVCMAX),RBAS(3,3),TAU(3,NPAT)
     &   ,TT(0:NPOLMAX,0:NSHEMAX,NSORTMAX),XINT(0:NSHEMAX,NSORTMAX)
     &   ,WS(NVCMAX),POLI(3,NVCMAX),PCEL(3,NMSHMAX)
     &   ,SROU(NSORTMAX),RINT(0:NSHEMAX,NSORTMAX)
     &   ,WCEL(0:NSHEMAX,NMSHMAX),SMT(NSORTMAX)
	COMMON /CONTROL/MAN,LMTO,NLR,NINT,NPF               !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /LATTICE/RBAS                                !!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /LATPAR/ PAR                                 !!! from init
	COMMON /STORE1/ NP0,POLIST,NTR,LISTTR               !!! tmp.storage
	COMMON /SRFINP/ NDIV1,NDIV2                         !!! from init
	COMMON /INTMESH/NSHE,NPOL,SROU,RINT,XINT,TT         !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /WORD/   NVAL                                !!! from block
	DATA PI/3.141592653589793D0/
	SQPI43=SQRT(4.D0*PI/3.D0)
	ISORT=IS(IATOM)
C READ ATOMIC CELL ENVELOPOES INFORMATION
	IF(IATOM.EQ.1)REWIND(UNIT=9)
	READ(9) (TAU(K,IATOM),K=1,3)
	READ(9) RMIN,RMAX,RMT,RV,VOL
	READ(9) NP0,((POLIST(K,I),K=1,3),I=1,NP0)
	READ(9) NGR,(NTR(I),I=1,NGR)
	READ(9) (((LISTTR(K,I,J),K=1,3),I=1,NTR(J)),J=1,NGR)
	READ(9) ((POLI(K,I),K=1,3),I=1,NGR)
	READ(9) (WS(I),I=1,NGR),(IREFAT(I),I=0,NGR)
	EPS=(VOL-4.D0*PI/3.D0*(SMT(IS(IATOM))/PAR)**3)
	ALF=(SMT(IS(IATOM))+SROU(IS(IATOM)))/PAR/2.D0
	BET=(SROU(IS(IATOM))-SMT(IS(IATOM)))/PAR/2.D0
C  CALCULATE WEIGHTS AND THEIR POINTS FOR THE INTEGRATION
C  OVER POLYHEDRON INTERSTITIAL REGION
	CALL WGTPOL(NPOL(ISORT),NP0,POLIST,NTR,LISTTR,NGR,ALF,BET,
     &  NDIV2,NSHE(ISORT),TT(0,0,ISORT),PAR,NMSH,NMSG,WCEL,PCEL,TVOL)
	END


	SUBROUTINE DELSGRD(IATOM,JATOM,IA,NMSH,DWCEL,PCEL)
**************************************************************
*  The calculation of the weights for the integratoion       *
*  over the interstitial region. The calculation of their    *
*  gradients with respect to the displacement of the origin. *
*  After Dima.Yu.Savrasov (P.N.Lebedev PhysicaL Institute)   *
*  Last revision: 03.02.93.                                  *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (NTRMAX=NENVMAX)
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,LISTTR(3,NTRMAX,NENVMAX),NMSG(NENVMAX),IS(NPAT)
     &   ,NTR(NENVMAX),ISENV(0:NENVMAX),IREFAT(0:NVCMAX)
     &   ,NSHE(NSORTMAX),NPOL(0:NSORTMAX)
	DIMENSION POLIST(3,NVCMAX),RBAS(3,3),TAU(3,NPAT)
     &   ,TT(0:NPOLMAX,0:NSHEMAX,NSORTMAX),XINT(0:NSHEMAX,NSORTMAX)
     &   ,WS(NVCMAX),POLI(3,NVCMAX),PCEL(3,NMSHMAX),SMT(NSORTMAX)
     &   ,SROU(NSORTMAX),RINT(0:NSHEMAX,NSORTMAX)
     &   ,DWCEL(0:NSHEMAX,NMSHMAX)
	COMMON /CONTROL/MAN,LMTO,NLR,NINT,NPF               !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /LATTICE/RBAS                                !!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /LATPAR/ PAR                                 !!! from init
	COMMON /STORE1/ NP0,POLIST,NTR,LISTTR               !!! tmp.storage
	COMMON /SRFINP/ NDIV1,NDIV2                         !!! from init
	COMMON /INTMESH/NSHE,NPOL,SROU,RINT,XINT,TT         !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /WORD/   NVAL                                !!! from block
	SAVE POLI,NGR,WS,IREFAT
	DATA PI/3.141592653589793D0/
	SQPI43=SQRT(4.D0*PI/3.D0)
	ISORT=IS(IATOM)
	IF(IATOM.EQ.1.AND.JATOM.EQ.0.AND.IA.EQ.1)REWIND(UNIT=9)
C READ ATOMIC CELL INFORMATION
	IF(JATOM.EQ.0.AND.IA.EQ.1)THEN
	READ(9) (TAU(K,IATOM),K=1,3)
	READ(9) RMIN,RMAX,RMT,RV,VOL
	READ(9) NP0,((POLIST(K,I),K=1,3),I=1,NP0)
	READ(9) NGR,(NTR(I),I=1,NGR)
	READ(9) (((LISTTR(K,I,J),K=1,3),I=1,NTR(J)),J=1,NGR)
	READ(9) ((POLI(K,I),K=1,3),I=1,NGR)
	READ(9) (WS(I),I=1,NGR),(IREFAT(I),I=0,NGR)
	ENDIF
	EPS=(VOL-4.D0*PI/3.D0*(SMT(IS(IATOM))/PAR)**3)
	ALF=(SMT(IS(IATOM))+SROU(IS(IATOM)))/PAR/2.D0
	BET=(SROU(IS(IATOM))-SMT(IS(IATOM)))/PAR/2.D0
C  CALCULATE WEIGHTS AND THEIR POINTS FOR THE INTEGRATION
C  OVER POLYHEDRON INTERSTITIAL REGION
	CALL DELWPOL(NPOL(ISORT),NP0,POLIST,POLI,NTR,LISTTR,NGR,ALF,BET,
     &  NDIV2,NSHE(ISORT),TT(0,0,ISORT),PAR,NATOM,IATOM,JATOM,IA,WS,
     &  IREFAT,NMSH,NMSG,DWCEL,PCEL,TVOL)
	END




	SUBROUTINE WGTPOL(NPOL,NP0,POLIST,NTR,LISTTR,NGR,
     &  ALF,BET,IDIV0,NSHE,TT,PAR,NMSH,NMSG,WCEL,PCEL,TVOL)
**************************************************************
*  Program for integration over polyhedron by means of the   *
*  seventh order quadrature formula (see Abramovich, Stegun) *
*  Program returns the basis points and their weigths.       *
*  Adapted by S.Savrasov from DS-program. (MPI, Germany.)    *
*  Created 20.02.93, Last revised 20.02.93.                  *
**************************************************************
	INCLUDE 'PARAM.DAT'
	PARAMETER (NTRMAX=NENVMAX)
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER LISTTR(3,NTRMAX,NENVMAX),NTR(NENVMAX),NMSG(NENVMAX)
	DIMENSION POLIST(3,NVCMAX),X(3),X1(3),X2(3),WCH(0:NPOLMAX)
     &   ,WCEL(0:NSHEMAX,NMSHMAX),PCEL(3,NMSHMAX),WGT(0:NPOLMAX)
     &   ,WT(7),XW(3,7),XC(2,7),TT(0:NPOLMAX,0:NSHEMAX)
     &   ,C(0:NPOLMAX,0:NPOLMAX),CP(0:NPOLMAX,0:NPOLMAX,2)
	SAVE LAGF,Q15,QPI,WT,XC,C,CP
	DATA lagf/1/,idivmax/50/,pi/3.141592653589793d0/
	FF(XX,N)=(ALF**2*XX**(N+1)/(N+1)-2.D0*ALF*BET*XX**(N+2)/(N+2)+
     &            BET**2*XX**(N+3)/(N+3))*BET
	if (lagf.eq.1) then
	lagf=0
	q15=dsqrt(15.d0)
	qpi=dsqrt(pi)
	wt(1)=9.d0/40.d0
	wt(2)=(155.d0-q15)/1200.d0
	wt(3)=wt(2)
	wt(4)=wt(2)
	wt(5)=(155.d0+q15)/1200.d0
	wt(6)=wt(5)
	wt(7)=wt(5)
	xc(1,1)=1.d0/3.d0
	xc(2,1)=1.d0/3.d0
	xc(1,2)=(6.d0-q15)/21.d0
	xc(2,2)=(9.d0+2.d0*q15)/21.d0
	xc(1,3)=(9.d0+2.d0*q15)/21.d0
	xc(2,3)=(6.d0-q15)/21.d0
	xc(1,4)=(6.d0-q15)/21.d0
	xc(2,4)=(6.d0-q15)/21.d0
	xc(1,5)=(6.d0+q15)/21.d0
	xc(2,5)=(9.d0-2.d0*q15)/21.d0
	xc(1,6)=(6.d0+q15)/21.d0
	xc(2,6)=(6.d0+q15)/21.d0
	xc(1,7)=(9.d0-2.d0*q15)/21.d0
	xc(2,7)=(6.d0+q15)/21.d0
	c(0,0)=1.D0
	c(0,1)=0.D0
	c(1,1)=1.D0
	do 20 i=2,npolmax
	do 10 j=1,i
	c(j,i)=c(j-1,i-1)*2.d0-c(j,i-2)
  10    continue
	c(0,i)=-c(0,i-2)
  20    continue
	c(0,0)=c(0,0)/dsqrt(2.d0)
	do 30 i=0,npolmax
	do 30 j=0,npolmax
	cp(I,J,1)=c(I,J)*par**3
	cp(I,J,2)=c(I,J)*par**2
  30    continue
	endif
C ***** DO GLOBALLY OVER POLYHEDRON PLANES "NGR" *****
	tvol=0.d0
	imsh=0
	DO 300 I=1,NGR          ! over planes
	nmsg(i)=0
	n1=listtr(1,1,i)
	n2=listtr(2,1,i)
	n3=listtr(3,1,i)
	do 60 k=1,3
	x1(k)=polist(k,n2)-polist(k,n1)
	x2(k)=polist(k,n3)-polist(k,n1)
  60    continue
	x(1)=x1(2)*x2(3)-x1(3)*x2(2)
	x(2)=x1(3)*x2(1)-x1(1)*x2(3)
	x(3)=x1(1)*x2(2)-x1(2)*x2(1)
	sstr=SQRT(x(1)**2+x(2)**2+x(3)**2)
	xarc=(x(1)*polist(1,n1)+x(2)*polist(2,n1)+x(3)*polist(3,n1))/
     &  sstr
	DO 260 J=1,NTR(I)       ! over triangles in plane
	n1=listtr(1,j,i)
	n2=listtr(2,j,i)
	n3=listtr(3,j,i)
	do 80 k=1,3
	x1(k)=polist(k,n2)-polist(k,n1)
	x2(k)=polist(k,n3)-polist(k,n1)
  80    continue
	x(1)=x1(2)*x2(3)-x1(3)*x2(2)
	x(2)=x1(3)*x2(1)-x1(1)*x2(3)
	x(3)=x1(1)*x2(2)-x1(2)*x2(1)
	sstr=SQRT(x(1)**2+x(2)**2+x(3)**2)
	rcm=((polist(1,n1)+polist(1,n2)+polist(1,n3))**2+
     &  (polist(2,n1)+polist(2,n2)+polist(2,n3))**2+
     &  (polist(3,n1)+polist(3,n2)+polist(3,n3))**2)/9.d0
	idiv=idiv0*sqrt(sstr/rcm)/2.d0/qpi+1
	idiv=min(idivmax,idiv)
	anorm=xarc*sstr/2.d0/dble(idiv*idiv)
	do 90 k=1,3
	x1(k)=(polist(k,n2)-polist(k,n1))/DBLE(idiv)
	x2(k)=(polist(k,n3)-polist(k,n1))/DBLE(idiv)
  90    continue
	do 110 i1=1,7
	do 100 j1=1,3
	xw(j1,i1)=x1(j1)*xc(1,i1)+x2(j1)*xc(2,i1)
 100    continue
 110    continue
C  FOR DIRECT TRIANGLES:
	do 180 i1=0,idiv-1
	do 170 i2=0,idiv-1-i1
	do 160 i3=1,7
	do 120 k=1,3
	x(k)=DBLE(i1)*x1(k)+DBLE(i2)*x2(k)+polist(k,n1)+xw(k,i3)
 120    continue
	imsh=imsh+1
	nmsg(i)=nmsg(i)+1
	if(imsh.gt.nmshmax)stop'<WGTPOL>: nmshmax must be increased 
     &  in param.dat'
	r0=dsqrt(x(1)*x(1)+x(2)*x(2)+x(3)*x(3))
	r1=(alf-r0)/bet
	r2=1.d0
	pcel(1,imsh)=x(1)/r0 
	pcel(2,imsh)=x(2)/r0 
	pcel(3,imsh)=x(3)/r0 
	do 130 ipol=0,npol
	rr=(ff(r2,ipol)-ff(r1,ipol))/r0**3
	wgt(ipol)=rr*wt(i3)*anorm
 130    continue
	do 140 ipol=0,npol
	wch(ipol)=0.d0
	do 135 jpol=0,ipol
	wch(ipol)=wch(ipol)+cp(jpol,ipol,1)*wgt(jpol)
 135    continue
 140    continue
	wcel(0,imsh)=0.d0
	wcel(nshe+1,imsh)=0.d0
	do 150 ishe=1,nshe
	wcel(ishe,imsh)=0.d0
	do 145 ipol=0,npol
	wcel(ishe,imsh)=wcel(ishe,imsh)+wch(ipol)*
     &  tt(ipol,ishe)*2.d0/dble(nshe)
 145    continue
	tvol=tvol+wcel(ishe,imsh) ! volume of integration region
 150    continue
 160    continue
 170    continue
 180    continue
C  FOR REVERSE TRIANGLES:
	do 250 i1=1,idiv-1
	do 240 i2=1,idiv-i1
	do 230 i3=1,7
	do 190 k=1,3
	x(k)=DBLE(i1)*x1(k)+DBLE(i2)*x2(k)+polist(k,n1)-xw(k,i3)
 190    continue
	imsh=imsh+1
	nmsg(i)=nmsg(i)+1
	if(imsh.gt.nmshmax)stop'<WGTPOL>: nmshmax must be increased 
     &  in param.dat'
	r0=dsqrt(x(1)*x(1)+x(2)*x(2)+x(3)*x(3))
	r1=(alf-r0)/bet
	r2=1.d0
	pcel(1,imsh)=x(1)/r0 
	pcel(2,imsh)=x(2)/r0 
	pcel(3,imsh)=x(3)/r0 
	do 200 ipol=0,npol
	rr=(ff(r2,ipol)-ff(r1,ipol))/r0**3
	wgt(ipol)=rr*wt(i3)*anorm
 200    continue
	do 210 ipol=0,npol
	wch(ipol)=0.d0
	do 205 jpol=0,ipol
	wch(ipol)=wch(ipol)+cp(jpol,ipol,1)*wgt(jpol)
 205    continue
 210    continue
	wcel(0,imsh)=0.d0
	wcel(nshe+1,imsh)=0.d0
	do 220 ishe=1,nshe
	wcel(ishe,imsh)=0.d0
	do 215 ipol=0,npol
	wcel(ishe,imsh)=wcel(ishe,imsh)+wch(ipol)*
     &  tt(ipol,ishe)*2.d0/dble(nshe)
 215    continue
	tvol=tvol+wcel(ishe,imsh) ! volume of integration region
 220    continue
 230    continue
 240    continue
 250    continue
 260    continue                        ! over triangLes in plane
 300    continue                        ! over planes
	nmsh=imsh                       ! number of mesh points generated
	RETURN
	END


	SUBROUTINE DELWPOL(NPOL,NP0,POLIST,POLI,NTR,LISTTR,NGR,
     &  ALF,BET,IDIV0,NSHE,TT,PAR,NATOM,IATOM,JATOM,IA,WS,IREFAT,NMSH,
     &  NMSG,DWCEL,PCEL,TVOL)
**************************************************************
*  Program for integration over polyhedron by means of the   *
*  seventh order quadrature formula (see Abramovich, Stegun) *
*  Program returns the basis points and their weigths.       *
*  Adapted by S.Savrasov from DS-program. (MPI, Germany.)    *
*  Created 20.02.93, Last revised 20.02.93.                  *
**************************************************************
	INCLUDE 'PARAM.DAT'
	PARAMETER (NTRMAX=NENVMAX)
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER LISTTR(3,NTRMAX,NENVMAX),NTR(NENVMAX),NMSG(NENVMAX)
     &    ,IREFAT(0:NVCMAX)
	DIMENSION POLIST(3,NVCMAX),X(3),X1(3),X2(3)
     &   ,WT(7),XW(3,7),XC(2,7),TT(0:NPOLMAX,0:NSHEMAX),TP(3)
     &   ,C(0:NPOLMAX,0:NPOLMAX),CP(0:NPOLMAX,0:NPOLMAX,2)
     &   ,WS(NVCMAX),PCEL(3,NMSHMAX),POLI(3,NVCMAX)
     &   ,DWCEL(0:NSHEMAX,NMSHMAX),WCH(0:NPOLMAX)
     &   ,WGT(0:NPOLMAX)
	SAVE LAGF,QPI,Q15,WT,XC,C,CP
	DATA lagf/1/,idivmax/50/,pi/3.141592653589793d0/
	sq2=1.d0/sqrt(2.d0)
	if (lagf.eq.1) then
	lagf=0
	q15=dsqrt(15.d0)
	qpi=dsqrt(pi)
	wt(1)=9.d0/40.d0
	wt(2)=(155.d0-q15)/1200.d0
	wt(3)=wt(2)
	wt(4)=wt(2)
	wt(5)=(155.d0+q15)/1200.d0
	wt(6)=wt(5)
	wt(7)=wt(5)
	xc(1,1)=1.d0/3.d0
	xc(2,1)=1.d0/3.d0
	xc(1,2)=(6.d0-q15)/21.d0
	xc(2,2)=(9.d0+2.d0*q15)/21.d0
	xc(1,3)=(9.d0+2.d0*q15)/21.d0
	xc(2,3)=(6.d0-q15)/21.d0
	xc(1,4)=(6.d0-q15)/21.d0
	xc(2,4)=(6.d0-q15)/21.d0
	xc(1,5)=(6.d0+q15)/21.d0
	xc(2,5)=(9.d0-2.d0*q15)/21.d0
	xc(1,6)=(6.d0+q15)/21.d0
	xc(2,6)=(6.d0+q15)/21.d0
	xc(1,7)=(9.d0-2.d0*q15)/21.d0
	xc(2,7)=(6.d0+q15)/21.d0
	c(0,0)=1.D0
	c(0,1)=0.D0
	c(1,1)=1.D0
	do 20 i=2,npolmax
	do 10 j=1,i
	c(j,i)=c(j-1,i-1)*2.d0-c(j,i-2)
  10    continue
	c(0,i)=-c(0,i-2)
  20    continue
	c(0,0)=c(0,0)/dsqrt(2.d0)
	do 30 i=0,npolmax
	do 30 j=0,npolmax
	cp(I,J,1)=c(I,J)*par**3
	cp(I,J,2)=c(I,J)*par**2
  30    continue
	endif
C  START-UP:
	tvol=0.d0
	do 50 imsh=1,nmshmax
	do 40 ishe=0,nshe+1
	dwcel(ishe,imsh)=0.d0
  40    continue
  50    continue
C ***** DO GLOBALLY OVER DISPLACED ATOMS *****
	DO 310 KATOM=1,NATOM    ! over moving atoms
	if(katom.ne.jatom.and.jatom.ne.0)goto 310
	imsh=0
C ***** DO GLOBALLY OVER POLYHEDRON PLANES "NGR" *****
	DO 300 I=1,NGR          ! over planes
	tp(1)=poli(1,i)
	tp(2)=poli(2,i)
	tp(3)=poli(3,i)
	tpm=sqrt(tp(1)*tp(1)+tp(2)*tp(2)+tp(3)*tp(3))
	nmsg(i)=0
	n1=listtr(1,1,i)
	n2=listtr(2,1,i)
	n3=listtr(3,1,i)
	do 60 k=1,3
	x1(k)=polist(k,n2)-polist(k,n1)
	x2(k)=polist(k,n3)-polist(k,n1)
  60    continue
	x(1)=x1(2)*x2(3)-x1(3)*x2(2)
	x(2)=x1(3)*x2(1)-x1(1)*x2(3)
	x(3)=x1(1)*x2(2)-x1(2)*x2(1)
	sstr=SQRT(x(1)**2+x(2)**2+x(3)**2)
	xarc=(x(1)*polist(1,n1)+x(2)*polist(2,n1)+x(3)*polist(3,n1))/
     &  sstr
	DO 260 J=1,NTR(I)       ! over triangles in plane
	n1=listtr(1,j,i)
	n2=listtr(2,j,i)
	n3=listtr(3,j,i)
	do 80 k=1,3
	x1(k)=polist(k,n2)-polist(k,n1)
	x2(k)=polist(k,n3)-polist(k,n1)
  80    continue
	x(1)=x1(2)*x2(3)-x1(3)*x2(2)
	x(2)=x1(3)*x2(1)-x1(1)*x2(3)
	x(3)=x1(1)*x2(2)-x1(2)*x2(1)
	sstr=SQRT(x(1)**2+x(2)**2+x(3)**2)
	rcm=((polist(1,n1)+polist(1,n2)+polist(1,n3))**2+
     &  (polist(2,n1)+polist(2,n2)+polist(2,n3))**2+
     &  (polist(3,n1)+polist(3,n2)+polist(3,n3))**2)/9.d0
	idiv=idiv0*sqrt(sstr/rcm)/2.d0/qpi+1
	idiv=min(idivmax,idiv)
	anorm=sstr/2.d0/dble(idiv*idiv)
	do 90 k=1,3
	x1(k)=(polist(k,n2)-polist(k,n1))/DBLE(idiv)
	x2(k)=(polist(k,n3)-polist(k,n1))/DBLE(idiv)
  90    continue
	do 110 i1=1,7
	do 100 j1=1,3
	xw(j1,i1)=x1(j1)*xc(1,i1)+x2(j1)*xc(2,i1)
 100    continue
 110    continue
C  FOR DIRECT TRIANGLES:
	do 180 i1=0,idiv-1
	do 170 i2=0,idiv-1-i1
	do 160 i3=1,7
	do 120 k=1,3
	x(k)=DBLE(i1)*x1(k)+DBLE(i2)*x2(k)+polist(k,n1)+xw(k,i3)
 120    continue
	imsh=imsh+1
	nmsg(i)=nmsg(i)+1
	if(imsh.gt.nmshmax)stop'<WGTPOL>: nmshmax must be increased 
     &  in param.dat'
	r0=dsqrt(x(1)*x(1)+x(2)*x(2)+x(3)*x(3))
	r1=(alf-r0)/bet
	r2=1.d0
	pcel(1,imsh)=x(1)/r0 
	pcel(2,imsh)=x(2)/r0 
	pcel(3,imsh)=x(3)/r0 
	if(irefat(i).ne.katom)goto160
	dc=-(x(ia)-tp(ia))/tpm
	do 130 ipol=0,npol
	rr=r1**ipol
	wgt(ipol)=rr*dc*wt(i3)*anorm
 130    continue
	do 140 ipol=0,npol
	wch(ipol)=0.d0
	do 135 jpol=0,ipol
	wch(ipol)=wch(ipol)+cp(jpol,ipol,2)*wgt(jpol)
 135    continue
 140    continue
	do 150 ishe=1,nshe
	do 145 ipol=0,npol
	dwcel(ishe,imsh)=dwcel(ishe,imsh)+wch(ipol)*
     &  tt(ipol,ishe)*2.d0/dble(nshe)
 145    continue
 150    continue
 160    continue
 170    continue
 180    continue
C  FOR REVERSE TRIANGLES:
	do 250 i1=1,idiv-1
	do 240 i2=1,idiv-i1
	do 230 i3=1,7
	do 190 k=1,3
	x(k)=DBLE(i1)*x1(k)+DBLE(i2)*x2(k)+polist(k,n1)-xw(k,i3)
 190    continue
	imsh=imsh+1
	nmsg(i)=nmsg(i)+1
	if(imsh.gt.nmshmax)stop'<WGTPOL>: nmshmax must be increased 
     &  in param.dat'
	r0=dsqrt(x(1)*x(1)+x(2)*x(2)+x(3)*x(3))
	r1=(alf-r0)/bet
	r2=1.d0
	pcel(1,imsh)=x(1)/r0 
	pcel(2,imsh)=x(2)/r0 
	pcel(3,imsh)=x(3)/r0 
	if(irefat(i).ne.katom)goto230
	dc=-(x(ia)-tp(ia))/tpm
	do 200 ipol=0,npol
	rr=r1**ipol
	wgt(ipol)=rr*dc*wt(i3)*anorm
 200    continue
	do 210 ipol=0,npol
	wch(ipol)=0.d0
	do 205 jpol=0,ipol
	wch(ipol)=wch(ipol)+cp(jpol,ipol,2)*wgt(jpol)
 205    continue
 210    continue
	do 220 ishe=1,nshe
	do 215 ipol=0,npol
	dwcel(ishe,imsh)=dwcel(ishe,imsh)+wch(ipol)*
     &  tt(ipol,ishe)*2.d0/dble(nshe)
 215    continue
 220    continue
 230    continue
 240    continue
 250    continue
 260    continue                        ! over triangLes in plane
 300    continue                        ! over planes
	nmsh=imsh                       ! number of mesh points generated
 310    continue                        ! over moving atoms
	RETURN
	END

